<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

#
# IRSR entrances -- a system login include file.
#

if ( !defined('IN_LOGIN_PROCESS') ) {		// This var is defined in the "including" file.
	die("<br>Unauthorized file entry !!!<br>");
}

print "<HEAD>\n";				// Display the invisionix favicon.ico.
print "<link rel='shortcut icon' href=\"favicon.ico\" type=\"image/x-icon\">\n";
print "<link rel='icon' type='image/ico' href=\"favicon.ico\">\n";
print "<SCRIPT>\n";
print "<!--\n";
print "ie = (document.all) ? true : false;\n";
print "function mouseOverThis(obj) { obj.style.cursor = (ie) ? 'hand' : 'pointer' }  // Show a 'hand' icon for a cursor.\n";
print "//-->\n";
print "</SCRIPT>\n";
print "</HEAD>\n";


//
//  Various login entrance
//  types supporting routines.
//

$loginFormName = "loginForm";			// Name of the login form.
$generatedEncPassCode = genEncPassRoutine($loginFormName); // Get the login password encryption JS source code.
echo $generatedEncPassCode;			// Instantiate the JS script code inline here.

function windowTypeMenu() {			// Set up the code for the login Window Type selection menu.
	global $_sysWinOptionsList, $sysEntrance_index, $sysETchg_index;

	$selectedJScode = " for (var k=0; k<".count($_sysWinOptionsList)."; k++)";	// Setup JS code for determining the window type index change.
	$selectedJScode .= " if (this.form.winTypeMenu.options[k].selected == true) {this.form.sysETchg_index.value = (k);} ;";

	$ret .= "<select name='winTypeMenu' onchange='".$selectedJScode." this.form.submit();'>\n";
	for($i=0; $i<count($_sysWinOptionsList); $i++) {
		if ($sysEntrance_index == $i) {		// This is the selected or the default option value, so item has to be "selected".
			$ret .= "<option value='".$_sysWinOptionsList[$i]."' SELECTED>".$_sysWinOptionsList[$i]."</option>\n";
		} else {				// This item is not the selected one.
			$ret .= "<option value='".$_sysWinOptionsList[$i]."'>".$_sysWinOptionsList[$i]."</option>\n";
		}
	}
	$ret .= "</select>\n";

	return $ret;
}

function generateAnEntrance() {			// Build an entrance for the other routines.
global  $_sysName, $_sysLocation, $_sysVersionPrefix, $_sysVersionNum, $_sysVersionPostfix;
global  $_sysDefaultPage, $_sysWinOptionsList;
global  $session, $sysETchg_index, $loginFormName;

$winTypeSelectMenu = windowTypeMenu();		// Generate the login entrance "window type" select menu.

//
//  Generate the screen layout, input, and output code.
//
$entrCode = <<<ENTRANCE
 <BODY onload='document.{$loginFormName}.username.focus();' topmargin='0' target='_top'>
 <center>
 <h5>
 <p><img border='0' src='bluebar_top.gif' alt='Entrance' width='300' height='5'>
 <br>$_sysName ...<br> $_sysLocation -- $_sysVersionPrefix$_sysVersionNum$_sysVersionPostfix</p>
 <FORM name='$loginFormName' action=$PHP_SELF?session=$session&sysETchg_index=$sysETchg_index method='POST' onsubmit='' target='_top'>
 Username: <input type='text' name='username' onMouseOver='javascript: focus()'>
 <br>Password: <input type='password' name='pass'><br>
 <br>secure: <input type='checkbox'  name='secure' value=''>
 &nbsp;<input type='button' name='enter' value=' L O G I N ' onclick='encPass(); this.form.submit();' onmouseover='mouseOverThis(this);'>
 &nbsp;via&nbsp;$winTypeSelectMenu
 <input type='hidden' name='mode' value='login'>
 <input type='hidden' name='sysETchg_index'>
 </FORM>
 <p align=center><img border='0' src='bluebar_bottom.gif' alt='Entrance' width='300' height='5'></p>
 </h5>
 </center>
 </BODY>
ENTRANCE;

return $entrCode;				// Hand over the screen.
}

function pickAnEntrance() {			// Login with one of the available entrance types.
	global $_sysWinOptionsList, $sysEntrance_Index, $_sysET_index, $sysETchg_index;

	//  If the user did not change the entrance window type, then use
	//  the default value, otherwise use the chosen new value.
	//
	$sysEntrance_index = ($sysETchg_index == '')  ? $_sysET_index : $sysETchg_index;

	switch ($_sysWinOptionsList[$sysEntrance_index]) {
		case "console":
			consoleWindowEntrance(); // Standalone console window entrance style.
		break;
		case "browser-page":
			browserWindowEntrance(); // Inside the main browser window style.
		break;
		case "full-screen":
			fullScreenEntrance();	 // Full screen entrance style.
		break;
		default:
			browserWindowEntrance(); // Browser window entrance style.
		break;
	}
}

function adjustWindowsDisp() {			// Adjust the final disposition of the windows..
	global $session, $_sysInvisionixWebsiteURL;

	switch($session) {			// Use session ID to figure out if window is normal, cloned or was a manual login.
		case "":			// This login is done via a normal window.
			print "<script>window.parent.location.href='" . $_sysInvisionixWebsiteURL . "';</script>\n";	// Point parent window to the current Invisionix website.
			print "<script>self.focus();</script>\n"; // Focus the window.
		break;
		case "do-a-ManualLogout": 	// This login is done  from a "manual button" window.
			print "<script>window.parent.close();</script>\n";	// Eliminate the Console window.
		break;
		default:			// Handle a "cloned" window login.
			print "<script>history.back(-1);</script>\n"; // Remain at the user's website.
		break;
	}
}


//
// Three types of entrances:
//	1. Browser-page environment style.
//	2. Standalone console style.
//	3. Full-screen style.
//

function browserWindowEntrance() {		// Create an entrance inside the main browser window.
	global $_sysRootURLdefault, $_sysORGwebsiteURL;

	print "<HTML>\n";
	print "<HEAD>\n";
	print "<META name='robots' content='noindex,nofollow,noarchive'>\n";
	checkforJavaScript();			// Test for Javascript's availability.
	if ($_sysDEBUG)	print "<script>document.write('Javascript version:' + JSVer() + '<br>');</script>\n";
	disableBadKeys();		// Disable undesireable key and mouse requests.
	print "</HEAD>\n";

	$theCode = generateAnEntrance();	// Create the entrance;
	print $theCode;				// Paint the screen with the entrance.
	print "<center><font size='1'>\n";
	print "<button type='button' name='invisionixLink' value='' onclick='window.open(\"$_sysORGwebsiteURL\");' onMouseOver='this.src=\"invisionix.png\"; mouseOverThis(this);'><img src='invisionix_gold.png' alt='Invisionix Systems' style='border: 0px;' onMouseOver='this.src=\"invisionix.png\";' onMouseOut='this.src=\"invisionix_gold.png\";' /></button>&nbsp;&nbsp;&nbsp\n";
	print "The '<strong>Alt-F4</strong>' keys close this window&nbsp;&nbsp;&nbsp\n";
	print "<button type='button' name='registration' value='Register' onclick='location.href=\"{$_sysRootURLdefault}/authenticate/register.php\";' onMouseOver=\"this.src='invisionix.png'; mouseOverThis(this);\">Register&nbsp;&nbsp<img src='invisionix_gold.png' alt='Login Account Registration' onMouseOver=\"this.src='invisionix.png';\" onMouseOut=\"this.src='invisionix_gold.png';\"></button>\n";
	print "</font></center><br>\n";

	print "</HTML>\n";
}

function consoleWindowEntrance() {		// Create the entrance in a standalone new console window.
	global  $_sysLocation, $loginFormName;

	$theBars = "directories=no,location=no,menubar=no,status=no,titlebar=no,toolbar=no";
	$theOptions = "scrollbars=no,width=600,height=325,resizable=YES";
	$theFeatures = $theBars . "," . $theOptions;
	$today = time();			// Get the time for creating the console window name.
	$consName = $_sysLocation . "_" . $today; // Creating the console window name.

	print "<script>";
	print "if (this.name != '" . $consName . "'){";	// Take over the whole screen.
	print	  "var consWin = window.open(location.href,'" . $consName . "','" . $theFeatures . "')";
	print "} ";
	print "</script>\n";

	browserWindowEntrance();		// Now do the same as the browser-entrance type window.

	print "<script>consWin.document.focus();</script>\n";		// Bring focus to new window.
	print "<script>consWin.document.close();</script>\n";	// Close the document stream.
	print "<script>consWin.focus();</script>\n";		// Bring focus to username field.

	adjustWindowsDisp();			// Adjust final disposition of various windows.
}

function fullScreenEntrance() {			// Create an entrance on the full screen.
	global  $loginFormName;

	print "<script>";
	print "if (this.name != 'fullscreen'){"; // Take over the whole screen.
	print	  "var fullWin = window.open(location.href,'fullscreen','fullscreen,scrollbars')";
	print "} ";
	print "</script>\n";

	browserWindowEntrance();		// Now do the same as the browser-entrance type window.

	print "<script>fullWin.document.focus();</script>\n";		// Bring focus to new window.
	print "<script>fullWin.document.close();</script>\n";	// Close the document stream.
	print "<script>fullWin.focus();</script>\n";		// Bring focus to username field.

	adjustWindowsDisp();		// Adjust final disposition of various windows.
}

?>

