<?php

//   -------------------------------------------------------------------------------
//  |                  net2ftp: a web based FTP client                              |
//  |                Copyright (c) 2003 by David Gartner                            |
//  |                                                                               |
//  | This program is free software; you can redistribute it and/or                 |
//  | modify it under the terms of the GNU General Public License                   |
//  | as published by the Free Software Foundation; either version 2                |
//  | of the License, or (at your option) any later version.                        |
//  |                                                                               |
//   -------------------------------------------------------------------------------





// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **
function getSkinArray() {


// --------------
// This function returns an array of skin names, file names, ...
// --------------

	$skinArray[1]['name'] = "Default";
	$skinArray[1]['css'] = "skin1-default.css";

	$skinArray[2]['name'] = "Blue";
	$skinArray[2]['css'] = "skin2-blue.css";

	$skinArray[3]['name'] = "Low contrast grey";
	$skinArray[3]['css'] = "skin3-grey.css";

	$skinArray[4]['name'] = "Black";
	$skinArray[4]['css'] = "skin4-black.css";

	return $skinArray;

} // End function getSkinArray

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************





// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **
function printSkinSelect() {


// --------------
// This function prints a select with the available skins
// Skin nr 1 is the default skin
// --------------

// -------------------------------------------------------------------------
// Global variables and settings
// -------------------------------------------------------------------------
	global $net2ftpcookie_skin;

	$skinArray = getSkinArray();

// -------------------------------------------------------------------------
// If there is only one skin, do not print the select, but print a hidden input field
// -------------------------------------------------------------------------
	if (sizeof($skinArray) == 1) {
		echo "<input type=\"hidden\" name=\"input_skin\" value=\"1\">\n";
	}

// -------------------------------------------------------------------------
// If there are more than one skin, print the select
// Pre-select the skin that was last used (using the cookie value)
// -------------------------------------------------------------------------
	else {
		echo "<select name=\"input_skin\" id=\"input_skin\">\n";

// There is no cookie information; set the default skin
		if ($net2ftpcookie_skin == "") { 
			echo "<option value=\"1\" selected>" . $skinArray[1]['name'] . "</option>\n"; 
			for ($i=2; $i<=sizeof($skinArray); $i=$i+1) {
				echo "<option value=\"$i\">" . $skinArray[$i]['name'] . "</option>\n";
			} // end for
		} // end if

// The cookie contains the last skin used; preselect that one
		else {
			for ($i=1; $i<=sizeof($skinArray); $i=$i+1) {
				if ($i == $net2ftpcookie_skin) { $selected = "selected"; }
				else { $selected = ""; }
				echo "<option value=\"$i\" $selected>" . $skinArray[$i]['name'] . "</option>\n";
			} // end for
		} // end else

		echo "</select>\n";
	}

} // End function printSkinSelect

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************





// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **

function getBrowseColors($skin, $what) {

	if ($skin == "1" || $skin == "2") {
		if     ($what == "heading_fontcolor")   { return "#000000"; }
		elseif ($what == "heading_bgcolor")     { return "#CCCCFF"; }
		elseif ($what == "rows_fontcolor_odd")  { return "#000000"; }
		elseif ($what == "rows_bgcolor_odd")    { return "#FFFFFF"; }
		elseif ($what == "rows_fontcolor_even") { return "#000000"; }
		elseif ($what == "rows_bgcolor_even")   { return "#EFEFEF"; }
		elseif ($what == "cursor_fontcolor")    { return "#000000"; }
		elseif ($what == "cursor_bgcolor")      { return "#9999FF"; }
		elseif ($what == "border_color")        { return "#000000"; }
	}
	elseif ($skin == "3") {
		if     ($what == "heading_fontcolor")   { return "#000000"; }
		elseif ($what == "heading_bgcolor")     { return "#EEEEEE"; }
		elseif ($what == "rows_fontcolor_odd")  { return "#000000"; }
		elseif ($what == "rows_bgcolor_odd")    { return "#FFFFFF"; }
		elseif ($what == "rows_fontcolor_even") { return "#000000"; }
		elseif ($what == "rows_bgcolor_even")   { return "#EEEEEE"; }
		elseif ($what == "cursor_fontcolor")    { return "#000000"; }
		elseif ($what == "cursor_bgcolor")      { return "#DDDDDD"; }
		elseif ($what == "border_color")        { return "#000000"; }
	}
	elseif ($skin == "4") {
		if     ($what == "heading_fontcolor")   { return "#FFFFFF"; }
		elseif ($what == "heading_bgcolor")     { return "#5E5E5E"; }
		elseif ($what == "rows_fontcolor_odd")  { return "#FFFFFF"; }
		elseif ($what == "rows_bgcolor_odd")    { return "#000000"; }
		elseif ($what == "rows_fontcolor_even") { return "#FFFFFF"; }
		elseif ($what == "rows_bgcolor_even")   { return "#232323"; }
		elseif ($what == "cursor_fontcolor")    { return "#000000"; }
		elseif ($what == "cursor_bgcolor")      { return "#898033"; }
		elseif ($what == "border_color")        { return "#000000"; }
	}
	else {
		if     ($what == "heading_fontcolor")   { return "#000000"; }
		elseif ($what == "heading_bgcolor")     { return "#CCCCFF"; }
		elseif ($what == "rows_fontcolor_odd")  { return "#000000"; }
		elseif ($what == "rows_bgcolor_odd")    { return "#FFFFFF"; }
		elseif ($what == "rows_fontcolor_even") { return "#000000"; }
		elseif ($what == "rows_bgcolor_even")   { return "#EFEFEF"; }
		elseif ($what == "cursor_fontcolor")    { return "#000000"; }
		elseif ($what == "cursor_bgcolor")      { return "#9999FF"; }
		elseif ($what == "border_color")        { return "#000000"; }
	}

} // end  function getBrowseColors

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************





// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **

function getHtmlColors() {

// --------------
// This function returns an array which contains the colors used by the HTML highligher
// Written by Slynderdale
// --------------

$html_highlight = array(
  'html' => array(
    'format' => "<nobr>\n<pre>\n<font color=\"{color}\">\n{html}\n</font>\n</pre>\n</nobr>", 
    'color' => '#000000'
  ),
  'default' => array(
    'format' => "<font color=\"{color}\">{html}</font>", 
    'color' => '#006600'
  ),
  'tag' => array(
    'format' => "<font color=\"{color}\">{html}</font>", 
    'color' => '#000080',
    0 => array('tags' => array('table','tr','td','th','tbody','thead'), 'color' => '#008080'),
    1 => array('tags' => array('form','input','select','option','textarea','label'), 'color' => '#FF3000'),
    2 => array('tags' => array('script'), 'color' => '#800000'),
    3 => array('tags' => array('style'), 'color' => '#800080'),
    4 => array('tags' => array('a'), 'color' => '#008000'),
    5 => array('tags' => array('img'), 'color' => '#800080'),
    'count' => '6'
  ),
  'comment' => array(
    'format' => "<font color=\"{color}\"><i>{html}</i></font>", 
    'color' => '#FF9900'
  ),
  'string' => array(
    'format' => "<font color=\"{color}\">{html}</font>", 
    'color' => '#CC0000'
  ),
  'entity' => array(
    'format' => "<i><b>{html}</b></i>", 
    'color' => ''
  ),
  'keyword' => array(
    'format' => "<font color=\"{color}\">{html}</font>", 
    'color' => '#0000CC'
  )
);

	return $html_highlight;

} // end  function getHtmlColors

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************




// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **

function getMime($filename, $browser) {

// --------------
// Checks the extension of a file to determine which is the type of the file and the icon
// --------------

// -------------------------------------------------------------------------
// Global variables and settings
// -------------------------------------------------------------------------
	$use_gif_images = getSetting("use_gif_images");

	$last = get_filename_extension($filename);

// -------------------------------------------------------------------------
// DIRECTORIES
// -------------------------------------------------------------------------
	if ($last == "directory") {
		$icon = "folder2";
		$type = "Directory";
	}

// -------------------------------------------------------------------------
// SYMLINKS
// -------------------------------------------------------------------------
	elseif ($last == "symlink") {
		$icon = "folder2_yellow";
		$type = "Symlink";
	}

// -------------------------------------------------------------------------
// FILES
// -------------------------------------------------------------------------

// Web files
	elseif ($last == "asp") {
		$icon = "";
		$type = "ASP script";	
	}
	elseif ($last == "css") {
		$icon = "stylesheet";
		$type = "Cascading Style Sheet";	
	}
	elseif ($last == "htm" || $last == "html") {
		$icon = "html";
		$type = "HTML file";	
	}
	elseif ($last == "java") {
		$icon = "source_java";
		$type = "Java source file";	
	}
	elseif ($last == "js") {
		$icon = "";
		$type = "JavaScript file";	
	}
	elseif ($last == "php") {
		$icon = "php-icon-new";
		$type = "PHP script";	
	}
	elseif ($last == "txt") {
		$icon = "document2";
		$type = "Text file";	
	}

// Images
	elseif ($last == "bmp") {
		$icon = "images";
		$type = "Bitmap file";	
	}
	elseif ($last == "gif") {
		$icon = "images";
		$type = "GIF file";	
	}
	elseif ($last == "jpg" || $last == "jpeg") {
		$icon = "images";
		$type = "JPEG file";	
	}
	elseif ($last == "png") {
		$icon = "images";
		$type = "PNG file";	
	}
	elseif ($last == "tif" || $last == "tiff") {
		$icon = "images";
		$type = "TIF file";	
	}
	elseif ($last == "xcf") {
		$icon = "gimp";
		$type = "GIMP file";	
	}

// Executables and scripts
	elseif ($last == "exe" || $last == "com") { 
		$icon = "exec";
		$type = "Executable";	
	}
	elseif ($last == "sh") { 
		$icon = "shellscript";
		$type = "Shell script";	
	}

// MS Office
	elseif ($last == "doc") { 
		$icon = "";
		$type = "MS Office - Word document";	
	}
	elseif ($last == "xls") { 
		$icon = "";
		$type = "MS Office - Excel spreadsheet";	
	}
	elseif ($last == "ppt") { 
		$icon = "";
		$type = "MS Office - PowerPoint presentation";	
	}
	elseif ($last == "mdb") { 
		$icon = "";
		$type = "MS Office - Access database";	
	}
	elseif ($last == "vsd") { 
		$icon = "";
		$type = "MS Office - Visio drawing";	
	}
	elseif ($last == "mpp") { 
		$icon = "";
		$type = "MS Office - Project file";	
	}

// OpenOffice 6
	elseif ($last == "sxw") { 
		$icon = "002_text_document";
		$type = "OpenOffice - Writer 6.0 document";	
	}
	elseif ($last == "stw") { 
		$icon = "003_text_template";
		$type = "OpenOffice - Writer 6.0 template";	
	}
	elseif ($last == "sxc") { 
		$icon = "004_spreadsheet_document";
		$type = "OpenOffice - Calc 6.0 spreadsheet";	
	}
	elseif ($last == "stc") { 
		$icon = "005_spreadsheet_template";
		$type = "OpenOffice - Calc 6.0 template";	
	}
	elseif ($last == "sxd") { 
		$icon = "006_drawing_document";
		$type = "OpenOffice - Draw 6.0 document";	
	}
	elseif ($last == "std") { 
		$icon = "007_drawing_template";
		$type = "OpenOffice - Draw 6.0 template";	
	}
	elseif ($last == "sxi") { 
		$icon = "008_presentation_document";
		$type = "OpenOffice - Impress 6.0 presentation";	
	}
	elseif ($last == "sti") { 
		$icon = "009_presentation_template";
		$type = "OpenOffice - Impress 6.0 template";	
	}
	elseif ($last == "sxg") { 
		$icon = "011_global_document";
		$type = "OpenOffice - Writer 6.0 global document";	
	}
	elseif ($last == "sxm") { 
		$icon = "015_math_document";
		$type = "OpenOffice - Math 6.0 document";	
	}

// StarOffice 5
	elseif ($last == "sdw") { 
		$icon = "002_text_document";
		$type = "StarOffice - StarWriter 5.x document";	
	}
	elseif ($last == "sgl") { 
		$icon = "011_global_document";
		$type = "StarOffice - StarWriter 5.x global document";	
	}
	elseif ($last == "sdc") { 
		$icon = "004_spreadsheet_document";
		$type = "StarOffice - StarCalc 5.x spreadsheet";	
	}
	elseif ($last == "sda") { 
		$icon = "006_drawing_document";
		$type = "StarOffice - StarDraw 5.x document";	
	}
	elseif ($last == "sdd") { 
		$icon = "008_presentation_document";
		$type = "StarOffice - StarImpress 5.x presentation";	
	}
	elseif ($last == "sdp") { 
		$icon = "010_presentation_compressed";
		$type = "StarOffice - StarImpress Packed 5.x file";	
	}
	elseif ($last == "smf") { 
		$icon = "015_math_document";
		$type = "StarOffice - StarMath 5.x document";	
	}
	elseif ($last == "sds") { 
		$icon = "013_chart_document";
		$type = "StarOffice - StarChart 5.x document";	
	}
	elseif ($last == "sdm") { 
		$icon = "001_star_butterfly";
		$type = "StarOffice - StarMail 5.x mail file";	
	}
 
// PDF and PS
	elseif ($last == "pdf") { 
		$icon = "pdf";
		$type = "Adobe Acrobat document";	
	}
	elseif ($last == "ps") { 
		$icon = "postscript";
		$type = "PostScript document";	
	}

// Archives
	elseif ($last == "arc") { 
		$icon = "tgz";
		$type = "ARC archive";	
	}
	elseif ($last == "arj") { 
		$icon = "tgz";
		$type = "ARJ archive";	
	}
	elseif ($last == "rpm") { 
		$icon = "rpm";
		$type = "RPM";	
	}	
	elseif ($last == "gz") { 
		$icon = "tgz";
		$type = "GZ archive";	
	}
	elseif ($last == "tar") { 
		$icon = "tar";
		$type = "TAR archive";	
	}
	elseif ($last == "zip") { 
		$icon = "tgz";
		$type = "Zip archive";	
	}

// Movies
	elseif ($last == "mov") { 
		$icon = "mime_video";
		$type = "MOV movie file";	
	}
	elseif ($last == "mpg" || $last == "mpeg") { 
		$icon = "mime_video";
		$type = "MPEG movie file";	
	}
	elseif ($last == "rm" || $last == "ram") { 
		$icon = "real";
		$type = "Real movie file";	
	}
	elseif ($last == "qt") { 
		$icon = "quicktime";
		$type = "Quicktime movie file";	
	}

// Flash
	elseif ($last == "fla") { 
		$icon = "";
		$type = "Shockwave flash file";	
	}
	elseif ($last == "swf") { 
		$icon = "";
		$type = "Shockwave file";	
	}


// Sound
	elseif ($last == "wav") { 
		$icon = "mime_audio";
		$type = "WAV sound file";	
	}

// Fonts
	elseif ($last == "ttf") {
		$icon = "font";
		$type = "Font file";	
	}

// Default
	else { 
		$icon = "mime";
		$type = "File";	
	}

// Default
	if ($icon == "") { $icon = "mime"; }
	if ($type == "") { $type = "File"; }

// Bigger icon
	$icon_onmouseover = $icon . "_big";

// GIF or PNG icon
	if ($browser == "IE" && $use_gif_images == "yes") { $icon .= ".gif"; $icon_onmouseover .= ".gif"; }
	else                                              { $icon .= ".png"; $icon_onmouseover .= ".png"; }

	$mime['mime_icon'] = "<img src=\"images/mime/$icon\" alt=\"icon\" />";
	$mime['mime_type'] = $type;

	return $mime;

} // end getMime

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************






// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **

function getAction($action, $onClick, $browser) {

// --------------
// Checks the icon related to an action
// --------------

// -------------------------------------------------------------------------
// Global variables and settings
// -------------------------------------------------------------------------
	$use_gif_images = getSetting("use_gif_images");

	if ($action == "back") { 
		$alt = "Back";
		$icon = "back";
	}
	elseif ($action == "forward") { 
		$alt = "Submit";
		$icon = "button_ok";
	}
	elseif ($action == "refresh") {
		$alt = "Refresh this page";
		$icon = "rebuild";
	}
	elseif ($action == "view_details") {
		$alt = "View details";
		$icon = "view_detailed";
	}
	elseif ($action == "view_icons") {
		$alt = "View icons";
		$icon = "view_icon";
	}
	elseif ($action == "listdirectories") {
		$alt = "List directories";
		$icon = "view_tree";
	}
	elseif ($action == "up") {
		$alt = "Go to the parent directory";
		$icon = "up";
	}
	elseif ($action == "newdirectory") { 
		$alt = "Create a new directory";
		$icon = "folder2";
	}
	elseif ($action == "newfile") { 
		$alt = "Create a new file";
		$icon = "mime";
	}
	elseif ($action == "uploadfile") { 
		$alt = "Upload files";
		$icon = "up";
	}
	elseif ($action == "advanced") { 
		$alt = "Go to the advanced page";
		$icon = "mime-audio";
	}
	elseif ($action == "logout") { 
		$alt = "Logout";
		$icon = "exit";
	}
	elseif ($action == "help") { 
		$alt = "Open the Help Guide in a new window";
		$icon = "info";
	}
	elseif ($action == "bookmark") { 
		$alt = "Bookmark this page";
		$icon = "bookmark";
	}
	elseif ($action == "save") { 
		$alt = "Save the current file";
		$icon = "filesave";
	}

// Default
	else { 
		$alt = "Default";
		$icon = "mime";
	}

// Default
	if ($alt  == "") { $alt  = "Default"; }
	if ($icon == "") { $icon = "mime"; }

// Normal and onMouseOver
	$icon_normal = $icon . "_light";
	$icon_onmouseover = $icon;

// GIF or PNG icon
	if ($browser == "IE" && $use_gif_images == "yes") { $icon_normal .= ".gif"; $icon_onmouseover .= ".gif"; }
	else                                              { $icon_normal .= ".png"; $icon_onmouseover .= ".png"; }

	$icon_total = "<a href=\"javascript: $onClick\"><img src=\"images/actions/$icon_normal\" alt=\"$alt\" style=\"border: 0px;\" onMouseOver=\"this.src='images/actions/$icon_onmouseover';\" onMouseOut=\"this.src='images/actions/$icon_normal';\" /></a>\n";

	return $icon_total;

} // end getAction

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************







// **************************************************************************************
// **************************************************************************************
// **                                                                                  **
// **                                                                                  **

function getMode($setting, $on_off, $onClick, $browser) {

// --------------
// Checks the icon related to a mode
// --------------

	global $use_gif_images;

	if ($setting == "details") {
		$alt = "View details";
		$icon = "view_detailed";
	}
	elseif ($setting == "icons") {
		$alt = "View icons";
		$icon = "view_icon";
	}

// Default
	else { 
		$alt = "Default";
		$icon = "mime";
	}

// Default
	if ($alt  == "") { $alt  = "Default"; }
	if ($icon == "") { $icon = "mime"; }

// On or off: icon and style
	if ($on_off == "on") { 
		$icon_normal      = $icon;
		$icon_onmouseover = $icon;
	}
	else {
		$icon_normal      = $icon . "_light";
		$icon_onmouseover = $icon;
	}

// GIF or PNG icon
	if ($browser == "IE" && $use_gif_images == "yes") { $icon_normal .= ".gif"; $icon_onmouseover .= ".gif"; }
	else                                              { $icon_normal .= ".png"; $icon_onmouseover .= ".png"; }

// DO NOT CLOSE THE IMAGE TAG TO ALLOW ADDITIONAL ACTIONS
	if ($on_off == "on") { 
		$icon_total = "<img src=\"images/settings/$icon_normal\" style=\"border: 2px solid #000000; padding-top: 1px; padding-left: 2px;\" alt=\"$alt\" />";
	}
	else {
		$icon_total = "<a href=\"javascript: $onClick\"><img src=\"images/settings/$icon_normal\" alt=\"$alt\" style=\"border: 0px;\" onMouseOver=\"this.src='images/settings/$icon_onmouseover';\" onMouseOut=\"this.src='images/settings/$icon_normal';\" /></a>\n";
	}

	return $icon_total;

} // end getMode

// **                                                                                  **
// **                                                                                  **
// **************************************************************************************
// **************************************************************************************

?>