<?PHP
#   -------------------------------------------------------------------------------
#  |                  net2ftp: a web based FTP client                              |
#  |                Copyright (c) 2003 by David Gartner                            |
#  |                                                                               |
#  | This program is free software; you can redistribute it and/or                 |
#  | modify it under the terms of the GNU General Public License                   |
#  | as published by the Free Software Foundation; either version 2                |
#  | of the License, or (at your option) any later version.                        |
#  |                                                                               |
#  | This program is distributed in the hope that it will be useful,               |
#  | but WITHOUT ANY WARRANTY; without even the implied warranty of                |
#  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 |
#  | GNU General Public License for more details.                                  |
#  |                                                                               |
#  | You should have received a copy of the GNU General Public License             |
#  | along with this program; if not, write to the Free Software                   |
#  | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA     |
#  |                                                                               |
#   -------------------------------------------------------------------------------

//ir
//ir  Try authentication here.
//ir
//ir require_once "http://irsr.emarriages.com/authenticate/auth.php";


// -------------------------------------------------------------------------
// Basic settings
// -------------------------------------------------------------------------

// Run the script to the end, even if the user hits the stop button
ignore_user_abort();

// Execute function shutdown() if the script reaches the maximum execution time (usually 30 seconds)
//register_shutdown_function("shutdown");

// Get settings file
require_once("settings.inc.php");
$settings = getSetting("ALL");

// The root directory cannot be determined from an include file (PHP bug),
// so this is the workaround
$application_rootdir = dirname(__FILE__);
$application_includesdir = $application_includesdir. "/includes";
$application_tempdir = $application_rootdir. "/temp";
$application_tempzipdir = $application_rootdir. "/temp";

// Set the error reporting level
if ($settings['error_reporting'] == "ALL")  { error_reporting(E_ALL); }
if ($settings['error_reporting'] == "NONE") { error_reporting(0); }
else                                        { error_reporting(E_ERROR | E_WARNING | E_PARSE); }


// -------------------------------------------------------------------------
// Functions
// -------------------------------------------------------------------------
require_once("./includes/net2ftp_loginform.inc.php");
require_once("./includes/authorizations.inc.php");
require_once("./includes/bookmark.inc.php");
require_once("./includes/browse.inc.php");
require_once("./includes/database.inc.php");
require_once("./includes/errorhandling.inc.php");
require_once("./includes/filesystem.inc.php");
require_once("./includes/html.inc.php");
require_once("./includes/homepage.inc.php");
require_once("./includes/languages.inc.php");
require_once("./includes/manage.inc.php");
require_once("./includes/skins.inc.php");
require_once("./includes/zip.lib.php");


// -------------------------------------------------------------------------
// Register global variables (POST, GET, GLOBAL, ...)
// -------------------------------------------------------------------------
require_once("./includes/registerglobals.inc.php");


// -------------------------------------------------------------------------
// Check authorizations
// -------------------------------------------------------------------------

if ($settings['check_authorization'] == "yes" && $net2ftp_ftpserver != "") {
	$resultArray = checkAuthorization($net2ftp_ftpserver, $net2ftp_ftpserverport, $net2ftp_username);
	$result = getResult($resultArray);
	if ($result == false) { printErrorMessage($resultArray, "exit", ""); }

}


// -------------------------------------------------------------------------
// Send HTTP headers
// -------------------------------------------------------------------------
require_once("./includes/httpheaders.inc.php");


// -------------------------------------------------------------------------
// Block the output to the browser and use compression if the browser supports it
// -------------------------------------------------------------------------
if ($settings['compress_output'] == "yes") { ob_start("ob_gzhandler"); }


// -------------------------------------------------------------------------
// Begin HTML output
// -------------------------------------------------------------------------
HtmlBegin("net2ftp", $state, $state2, $directory, $entry);


// ------------------------------------------------------------------------
// Main switch; functions are in include files "functions_somename.inc.php"
// -------------------------------------------------------------------------

switch ($state) {
	case "homepage":
		homepage($state2);
	break;
	case "browse":
		browse($state2, $directory, $FormAndFieldName, $browse_details);
	break;
	case "directorytree":
		directorytree($directory);
	break;
	case "manage":
		manage($state2, $directory, $entry, $selectedEntries, $newNames, $dirorfile, $formresult, $chmodStrings, $targetDirectories, $copymovedelete, $text, $wysiwyg, $uploadedFilesArray, $uploadedArchivesArray, $use_folder_names, $command, $to, $message);
	break;
	case "bookmark":
		bookmark($directory, $url, $text);
	break;
	case "logout":
		homepage($state2);
	break;
	case "feedback":
		printFeedbackForm($formresult);
	break;
	default:
		$resultArray['message'] = "Unexpected state string. Exiting."; 
		printErrorMessage($resultArray, "exit", "");
	break;
}


// -------------------------------------------------------------------------
// End HTML output
// -------------------------------------------------------------------------
HtmlEnd();


// -------------------------------------------------------------------------
// Send the output to the browser
// -------------------------------------------------------------------------
if ($settings['compress_output'] == "yes") { ob_end_flush(); }

?>