<?php

//   -------------------------------------------------------------------------------
//  |                  net2ftp: a web based FTP client                              |
//  |                Copyright (c) 2003 by David Gartner                            |
//  |                                                                               |
//  | This program is free software; you can redistribute it and/or                 |
//  | modify it under the terms of the GNU General Public License                   |
//  | as published by the Free Software Foundation; either version 2                |
//  | of the License, or (at your option) any later version.                        |
//  |                                                                               |
//  | This program is distributed in the hope that it will be useful,               |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of                |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 |
//  | GNU General Public License for more details.                                  |
//  |                                                                               |
//  | You should have received a copy of the GNU General Public License             |
//  | along with this program; if not, write to the Free Software                   |
//  | Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA     |
//  |                                                                               |
//   -------------------------------------------------------------------------------


//  ------------------------
// | Table of contents:     |
// |    General settings    |
// |    Technical settings  |
// |    Logging             |
// |    Authorizations      |
// |    Layout settings     |
//  ------------------------

// Get the IRSR system's global setting.
//

$globalIncludeFileRelativePath = "/system/includes/site.inc.php";	// Relative path to the system's global include file - Unix.
//$globalIncludeFileRelativePath = "\system\includes\site.inc.php";	// Relative path to the system's global include file - Windows.
$globalIncludeFilePath = getenv("DOCUMENT_ROOT");		// Obtain the base root path from the ISP's system.
$globalIncludeFilePath .= $globalIncludeFileRelativePath;	// Create the system's global include file path.
require_once	($globalIncludeFilePath);			// System's global include file.



function getSetting($setting) {

// ----------------------------------------------------------------------------------
// ------------------------------- General settings ---------------------------------
// ----------------------------------------------------------------------------------

// Enter the URL of net2ftp on your website
$settings['my_net2ftp_url'] = $n2f_locationURL;

// Enter your email address
$settings['email_feedback'] = $n2f_emailAddr;


// ----------------------------------------------------------------------------------
// ------------------------------- Technical settings -------------------------------
// ----------------------------------------------------------------------------------

// ---------------------------------
// Database settings, used to log the actions of the users (no password logging)
// ---------------------------------

// If you want to enable logging (see below), set this to "yes"
$settings['use_database'] = $n2f_doLogging;

// Enter your MySQL settings
$settings['dbusername'] = $n2f_DBuserLogin;
$settings['dbpassword'] = $n2f_DBuserPass;
$settings['dbname']     = $n2f_DBhostLoginAcct;
$settings['dbserver']   = $n2f_DBhostName;   // on many configurations, this is "localhost"


// ================================================================================

// ---------------------------------
// Browse settings 
// ---------------------------------

// Show hidden files on the FTP server
// Set to "yes" if you want net2ftp to show hidden directories and files.
// Set it to "no" if you don't care about hidden directories and files. This 
// will make net2ftp a little faster.
$settings['show_hidden_files'] = "yes";

// ---------------------------------
// Upload settings
// ---------------------------------

// Maximum upload filesize allowed **by net2ftp**
// Default: 5 mB, but users have reported it to work up to 15 MB
$settings['max_upload_size'] = "5000000"; // in Bytes

// IF YOU WANT TO ALLOW LARGE FILE UPLOADS, YOU MAY HAVE TO ADJUST
// THE FOLLOWING PARAMETERS:
// 1 - in the file php.ini: upload_max_filesize, post_max_size, 
//     max_execution_time, memory_limit
// 2 - in the file php.conf: LimitRequestBody

// Nr of files and archives that can be uploaded per page
$settings['nr_upload_files'] = "5";
$settings['nr_upload_archives'] = "5";


// ---------------------------------
// PHP error reporting. 
// ---------------------------------

// Set to "ALL" or "standard" while you are testing net2ftp
// Set to "NONE" once the testing is done

//$settings['error_reporting'] = "ALL";
//$settings['error_reporting'] = "NONE";
$settings['error_reporting'] = "standard";


// ---------------------------------
// Compress web pages (transmission between web server and browser)
// ---------------------------------
// Benefit: speeds up the transmission
// Drawback: puts more load on the web server's processor

// Set output compression to yes or no
$settings['compress_output'] = "no";


// ----------------------------------------------------------------------------------
// ------------------------------- Logging ------------------------------------------
// ----------------------------------------------------------------------------------

// Note: if you want to enable the logging, the $settings['use_database'] setting above
// must also be set to "yes"
$settings['log_access'] = "yes";
$settings['log_login'] = "yes";
$settings['log_error'] = "yes";


// ----------------------------------------------------------------------------------
// ------------------------------- Authorizations -----------------------------------
// ----------------------------------------------------------------------------------

// Choose if you want to perform these checks, each time a user requests a page:
// - If the FTP server is in the list of allowed FTP servers (you can set this to ALL)
// - If the FTP server is in the list of banned FTP servers
// - If the IP address of the user is in the list of banned IP addresses
// - If the FTP server port is in the range allowed

// Note: the checks on the FTP server are only performed on the primary FTP server. 
// It is possible to copy/move files from the primary FTP server to a second FTP server; this one is not checked.

$settings['check_authorization'] = "yes";


// ---------------------------------
// Allowed FTP servers: either set it to ALL, or else provide a list of allowed servers
// This will automatically change the layout of the login page:
//    - if ALL is entered, then the FTP server input field will be free text
//    - if only 1 entry is entered, then the FTP server input field will not be shown
//    - if more than 1 entry is entered, then the FTP server will have to be chosen from a drop-down list
// ---------------------------------

$settings['net2ftp_allowed_ftpservers'][1] = "ALL";
//$settings['net2ftp_allowed_ftpservers'][1] = "ftp.your-server.com";
//$settings['net2ftp_allowed_ftpservers'][2] = "192.168.1.1";
//$settings['net2ftp_allowed_ftpservers'][3] = "ftp.mydomain2.org";



// ---------------------------------
// Banned FTP servers
// Modify this entry, and add other entries if needed, but there should be at least one!
// ---------------------------------

$settings['net2ftp_banned_ftpservers'][1] = "ftp.download-music-for-free.com";


// ---------------------------------
// Banned IP addresses
// Modify this entry, and add other entries if needed, but there should be at least one!
// ---------------------------------

$settings['net2ftp_banned_addresses'][1] = "10.0.0.1";


// ---------------------------------
// Allowed FTP server port. 
// Set it either to ALL, or to a fixed number
// ---------------------------------

$settings['net2ftp_allowed_ftpserverport'] = "ALL";
//$settings['net2ftp_allowed_ftpserverport'] = "21";


// ---------------------------------
// Directory that is shown when the users log in
// ---------------------------------

// Which directory should be shown when the users log in for the first time?
//$settings['logindirectory'] = "";                    // home directory (can be set differently for each user on the FTP server)
$settings['logindirectory'] = "/";                 // root directory
//$settings['logindirectory'] = "/pub/linux";        // another directory. THIS ONLY MAKES SENSE IF YOU HAVE SET ONLY 1 net2ftp_allowed_ftpservers


// ----------------------------------------------------------------------------------
// ------------------------------- Layout settings ----------------------------------
// ----------------------------------------------------------------------------------

// ---------------------------------
// Skins
// ---------------------------------
// See the file /includes/skins.inc.php


// ---------------------------------
// Settings for the Browse screen
// Choose which column you want to see or hide (set to 0 or 1)
// ---------------------------------
$settings['browse_dir_size'] = 1; 
$settings['browse_dir_owner'] = 1; 
$settings['browse_dir_group'] = 1;
$settings['browse_dir_permissions'] = 1;
$settings['browse_dir_mtime'] = 1;

$settings['browse_file_size'] = 1;
$settings['browse_file_owner'] = 1;
$settings['browse_file_group'] = 1;
$settings['browse_file_permissions'] = 1;
$settings['browse_file_mtime'] = 1;


// ---------------------------------
// Settings for the Edit screen
// ---------------------------------
// Size of the textarea in which the files are edited
$settings['edit_nrofcolumns'] = "95";
$settings['edit_nrofrows'] = "28";
$settings['edit_nrofcolumns_wysiwyg'] = "95";
$settings['edit_nrofrows_wysiwyg'] = "25";

// ---------------------------------
// Settings for the Popup window of the list of directories
// ---------------------------------
$settings['popup_height'] = "450";
$settings['popup_width'] = "300";


// ---------------------------------
// Enable or disable GIF images?
//    The GIF images are covered by the Unisys LZW patent. If you live in a 
// country where the patent is valid, you may want to disable the use of 
// gif images. In that case, PNG images will be shown instead.
//    They work well on Mozilla browsers, but look not as nice on IE 
// (background is not transparent).
// ---------------------------------
$settings['use_gif_images'] = "yes";


// ----------------------------------------------------------------------------------
// ------------------------------- Application version ------------------------------
// ----------------------------------------------------------------------------------

$settings['application_version'] = "0.73";



if ($setting == "ALL")                                              { return $settings; }
elseif ($setting != "ALL" && array_key_exists($setting, $settings)) { return $settings[$setting]; }
else                                                                { return "Setting $setting does not exist"; }

} // end function getSetting
?>