<?PHP
# ------------------------------------------------------------------------------
#                           W  A  -  B  O  O
# ------------------------------------------------------------------------------
#  wa-boo is a GPL shareable web based address book working under PHP and MySQL
#  Copyright (C) Alexandre VICQ  -  axl@nocive.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# ------------------------------------------------------------------------------


    include ("includes/global_vars.php");
    include ("classes/database_class.php");
    include ("classes/user_class.php");
    include ("includes/fotools.php");
    
    global $G_default_langage;
    global $G_host_URL;
    global $G_email_header;
    global $G_email_footer;
    global $G_robot;

    
    session_start();   
    session_destroy();
    
    $s_lang == "" ? $s_lang = $G_default_langage : "";
    loadComboAndFields($s_lang); // load langage combos fields


    $conn  = new Database();
    $conn2  = new Database();

    // initializing the appearance before login
        $s_user_context["color"]["menu"]          = $G_user_menu_color;
        $s_user_context["color"]["button"]        = $G_user_button_color;
        $s_user_context["color"]["stdfontcolor"]  = $G_user_stdfont_color;
        $s_user_context["color"]["stdfontsize"]   = $G_user_stdfont_size;
        $s_user_context["color"]["listfontcolor"] = $G_user_listfont_color;
        $s_user_context["color"]["listfontsize"]  = $G_user_listfont_size;


    if ($OK == "OK") {
        $s_user = new User("",$login,$password,"");
        if ($s_user->checkUser($conn)) { // user exists 
            $s_user->loadUserData($conn, $conn2);
            $s_user->setUserSession_preferences($s_user->getUserPreferences());
            $s_user_context = $s_user->getUserSession_preferences();    // load user preferences & categories into context array
            
            $s_lang = $s_user->getUserLanguage();
            loadComboAndFields($s_lang);
            $s_boxLab = loadTemplateLabels($s_lang, "msgbox"); // load msg box labels in correct language
            
            // setting user color preferences
            $temp = $s_user->getUserColorPreferences();
            $s_user_context["color"]["menu"]          = $temp["menu"];
            $s_user_context["color"]["button"]        = $temp["button"];
            $s_user_context["color"]["stdfontcolor"]  = $temp["stdfontcolor"];
            $s_user_context["color"]["stdfontsize"]   = $temp["stdfontsize"];
            $s_user_context["color"]["listfontcolor"] = $temp["listfontcolor"];
            $s_user_context["color"]["listfontsize"]  = $temp["listfontsize"];
            

            session_register ("s_user", "s_user_context", "s_previous_page", "s_lang", "s_boxLab");
            
            $s_user->getUserRights();
            if ($adminlog == 1) { //admin check
                if ($s_user->getUserRights() == "GODLIKE" || $s_user->getUserRights($conn) == "ADMIN") { // user is Admin or GodLike
                    $s_user_type = $s_user->getUserRights();
                    $s_previous_page = "index.php";
                    session_register("s_user_type");
                    redirect("admin/adm_index.php");
                } 
            } else { // user 
                $s_domain_checkboxes = "INIT";    // just registering
                $s_previous_page = "index.php";
                session_register("s_domain_checkboxes");
                redirect("contacts.php");
           }
           $conn->close(); 
           $conn2->close(); 
           redirect("index.php");
        } else {
            $conn->close(); 
            $conn2->close(); 
            redirect("index.php");
        }
    }

    if ($public) {
        $s_user_type = "PUBLIC_USER";
        $s_previous_page = "index.php";
        session_register("s_user_type","s_previous_page", "s_lang");
        redirect("public.php");
    }

    if ($lostpasswd) {
        $lab = loadTemplateLabels($s_lang, "lostpasswd");
        require ("templates/lostpasswd.tmpl");
        die;
    }

    if ($sendpasswd) {
        $lab = loadTemplateLabels($s_lang, "lostpasswd");
        if ($checked_email = checkEmail($email)) {
            $lost_user = new User("","","",$email);
            if ($lost_user->checkUserWithEmail($conn)) {
                $lost_user->loadUserData($conn,$conn2);

                $email_subject = NoHTML_spaces($lab[5] /* Your login and password for */ . $G_host_URL);
                $email_message = NoHTML_spaces($G_email_header . $lab[6] /* Hello */ . $lost_user->getUserFirstname() . " " . $lost_user->getUserName() . "\n\n" . $lab[7] /* Here are your login and password for */ . $G_host_URL . " :\n\n" .  $lab[8] /* Login : */ . $lost_user->getUserLogin() . "\n" .  $lab[9] /* Password : */ . $lost_user->getUserPasswd() . "\n\n" . $G_email_footer);

                if (tuned_email($email, $email_subject, $email_message, $G_robot)) {  // syntax is $email_addresses_array, $s_email_subject, $s_email_message, from

                    $result_message = $lab[10] /* Your login and password have been sent to : */ . $email;
                    $message_color = "#006600";
                } else {
                    $result_message = $lab[11] /* problem sending email ! */;
                    $message_color = "#FF0000";
                }  
            } else {
                $result_message  = $email . $lab[12] /* is not a recorded email address ! */ . "<br>";
                //$result_message .= $email . $lab[13] /* is an invalid email address :-( */;
                $message_color = "#FF0000";
                require ("templates/lostpasswd.tmpl");
                die;
            }
        } else {
            $result_message .= $email . $lab[13] /* is an invalid email address :-( */;
            $message_color = "#FF0000";
            require ("templates/lostpasswd.tmpl");
            die;
        }
    }
    if (!$OK && !$lostpasswd) {
        $lab = loadTemplateLabels($s_lang, "login");
        require ("templates/login.tmpl");
    }
    $conn->close();
    $conn2->close();
?>