<?php
    // ------------------------------------------------------------------------------
    //                           W  A  -  B  O  O
    // ------------------------------------------------------------------------------
    //  wa-boo is a GPL shareable web based address book working under PHP and MySQL
    //  Copyright (C) Alexandre VICQ  -  axl@nocive.com
    //
    // This program is free software; you can redistribute it and/or
    // modify it under the terms of the GNU General Public License
    // as published by the Free Software Foundation; either version 2
    // of the License, or (at your option) any later version.
    // 
    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.
    // 
    // You should have received a copy of the GNU General Public License
    // along with this program; if not, write to the Free Software
    // Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    // ------------------------------------------------------------------------------


    include ("includes/global_vars.php");
    include ("classes/database_class.php");
    include ("classes/user_class.php");
    include ("classes/contact_class.php");
    include ("classes/domain_class.php");
    include ("classes/paging_class.php");
    include ("includes/fotools.php");
    
    session_start();
    
    
    // === AntiHack check ===
    if ($cID !="" && antiHack($cID,"integer")=="error") {
        msgBox ("1", "", $s_boxLab[7] /* Security !  <br><br>Session error ! */,
            $s_boxLab[4] /* Security ! */, "error",
            $s_boxLab[6] /* OK */, "index.php");
            die;
    }

    if (!session_is_registered("s_previous_page")) {  // session hacking / error
        msgBox ("1", "", $s_boxLab[7] /* Security !  <br><br>Session error ! */,
            $s_boxLab[4] /* Security ! */, "error",
            $s_boxLab[6] /* OK */, "index.php");
            die;
    }
    // === End of AntiHack check ===    
    
    $conn  = new Database();
    $conn2 = new Database();
    
    // ===== init vars to correctly display help (missing user vars :)
    $s_user_context["color"]["menu"] = $G_user_menu_color;
    
        
    if ($s_previous_page != "public.php") {   // if coming from other page than public.php, the first action is to list, not to show details
        $ct_whichaction = "LIST";
    }
     
    if ($ct_whichaction == "SHOWDETAILS") {     // if SHOWDETAILS needed, instanciate the Contact class
        $selected_contact = new Contact($cID);
        $selected_contact->loadContactData($conn);
        $selected_contact->getContactID();
        $user_owner = new User($selected_contact->getContactUserID(),"","","");
        $user_owner->loadUserData($conn, $conn2);
    }
 
    // Queries and paging step 
    // count query
    $sql_count = buildQuery("COUNT", "PUBLIC_USER", $user_ID, $query_fields, $i_chkPriCt, $i_search_category, $i_chkPubCt, $query_domains, $i_search_string, $i_search_position, $i_search_field, $i_search_letter, "", ""); // 2 last parameters ar defined by default in function. Not use four "COUNT" type
    $conn->execQuery($sql_count);
    $field = $conn->getNextRecord();
    $count_contact = $field["howmany"]; 
    $conn->freeResult();

    // init of paging system. 
    if( !isset( $current_position ) || $current_position == 0 ){ // init of position in paging system
      $current_position = 0;
    }
    if ($G_public_page_size == 0) {
        if ($count_contact != 0) {
            $page_size = $count_contact; // Number of contacts to display on the page, according to user preferences. If 0, means to show all in one page ($size = $count_contact)
        } else {
            $page_size = 1; // if nocontact, put to one to avoid paging class to divide by zero
        }
    } else {
        $page_size = $G_public_page_size;
    }
    // paging system. Build 2 arrays for display and links
    $paging = new Paging($count_contact, $current_position, $page_size, "&i_search_letter=" . $i_search_letter); // extra_arg not used
    $array_paging = $paging->getPagingArray();  // Load up the 2 array in order to display result in the .tmpl file
    $array_row_paging = $paging->getPagingRowArray();
    
    // $sql is the main query - $s_sql is most the same exept the LIMIT clause, in which we give the total rows $array_paging["total"]
    $sql   = buildQuery("RETURN", "PUBLIC_USER", "", "", $i_chkPriCt, $i_search_category, $i_chkPubCt, $query_domains, $i_search_string, $i_search_position, $i_search_field, $i_search_letter, $current_position, $page_size);
    $conn->execQuery($sql);
    
    // === Building the contact array ===  
    $contact = array();
    $k = 0;
    while ($field = $conn->getNextRecord()) {
        $contact[$k][0] = $field["cID"];
        $contact[$k][1] = $field["uID_FK"];
        for ($m = 2 ; $m < $G_nb_of_DB_fields ; $m++)    {    
            $contact[$k][$m] = convertStringFromDB($field[$m]); // all other fields
        }
        $k++;
    }
    $conn->freeResult();
    // === END of building the contact array === 
    
    // === Building the letters array ===
    $A_value = ord("A");              // ascii value of A
    $Z_value = ord("Z");
    $cpt = 0;
    for ($i = $A_value ; $i <= $Z_value ; $i++) {
       $letters_array["ascii_val"][$cpt++] = chr($i);    // create an array containing letters A to Z
    }

    for ($i = 0 ; $i < count($letters_array["ascii_val"]) ; $i++) { // the buildQuery is called with the COUNT parameter
        $sql = buildQuery("COUNT", "PUBLIC_USER", "", "", $i_chkPriCt, $i_search_category, $i_chkPubCt, $query_domains, $i_search_string, $i_search_position, $i_search_field, $letters_array["ascii_val"][$i],0,1000);
        $conn->execQuery($sql);
        $field = $conn->getNextRecord();
        $letters_array["display"][$i] = ($field["howmany"] == 0 ? 0 : 1);  // save letters with contacts
        $conn->freeResult();
    }
    // === END of Building the letters array ===
 
    $conn->close();
    $conn2->close();
    $s_previous_page = "public.php";
    $lab = loadTemplateLabels($s_lang, "contacts");
    require ("templates/public.tmpl");
?>