<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

# #######################################
#
#  This file contains the site's global
#  PROGRAM initialization values.
#
# #######################################

// ////////////////////////// //
//  Include data needed from  //
//  global system settings.   //
// ////////////////////////// //
//
$globalEnvFileRelativePath = "/system/includes/envfunctions.inc.php";	// Relative path to the system's global config file - Unix.
//$globalEnvFileRelativePath = "\system\includes\envfunctions.inc.php";	// Relative path to the system's global config file - Windows.
$globalConfigFileRelativePath = "/system/includes/config.inc.php";	// Relative path to the system's global config file - Unix.
//$globalConfigFileRelativePath = "\system\includes\config.inc.php";	// Relative path to the system's global config file - Windows.
$globalSiteIncFileRelativePath = "/system/includes/site.inc.php";	// Relative path to the system's global site include file - Unix.
//$globalSiteIncFileRelativePath = "\system\includes\site.inc.php";	// Relative path to the system's global site include file - Windows.
//
$globalSiteIncFilePath = getenv("DOCUMENT_ROOT");			// Obtain the base root path from the ISP's system.
$globalEnvFilePath = $globalSiteIncFilePath . $globalEnvFileRelativePath;		// Create the system's global configuration file path.
$globalConfigFilePath = $globalSiteIncFilePath . $globalConfigFileRelativePath;		// Create the system's global configuration file path.
$globalSiteIncFilePath = $globalSiteIncFilePath . $globalSiteIncFileRelativePath;	// Create the system's global site include file path.
//
require_once	($globalEnvFilePath);					// System's global environment function include file.
require_once	($globalConfigFilePath);				// System's global config file.
require_once	($globalSiteIncFilePath);				// System's global site include file.

// =================================================================================

// /////////////////////////////// //
//  The specific program related   //
//  settings section starts here.  //
// /////////////////////////////// //
//  NOTE: Use the section below to
//  set a program's absolute
//  initialization and configuration
//  values when you need these
//  variables to be used on a
//  site "global" basis.
//

$_prog_IncludesRelPath = "/programs/includes/";			// Relative path to the programs includes directory.
$_prog_n2fRelativePath = "/programs/apps/net2ftp/index.php";	// Net2FTP relative URL path.
$_prog_n2fLogging = "no";					// Net2FTP DB logging yes/no flag.
$_prog_pmaURIpath = "$_sysRootURIpath/programs/admin/apps/phpmyadmin";	// PhpMyAdmin URI path.
$_prog_DDmenuCssFile = "{$_prog_IncludesRelPath}style.inc.php";	// Tools global CSS file name.
$_prog_irsimJabSrvrFileLoc = getenv("DOCUMENT_ROOT") . "/programs/apps/irsim/jabber-servers.inc.php";	// Location of the IRSIM's Jabber Servers description file.
$_prog_wabEmailServerPref = "mail";				// Waboo Addressbook email server domain prefix value: "email" or "mail" ("email" is  for french provider online.fr, "mail" for classical providers)
$_prog_wabEmailDomainName = "YourDomainName.com";		// Waboo Addressbook "your_domain.com" setting.
//
$_prog_irsimIdent = "IRSIM";					// The IRSIM program's identity label.
$_prog_irsim_minutesUp = 120;					// Minutes connection, maximum (in one time.)
$_prog_irsimJabberAdmin = "YourIRSIMadminName";			// IRSIM jabber Admin name (Create such a free admin account on some free Jabber server out there.)
$_prog_irsimWinWidth =  '200';					// IRSIM primary window's pixel width.
$_prog_irsimWinHeight = '300';					// IRSIM primary window's pixel height.
$irsimDefaultHostLabel = "zim";					// IRSIM DEFAULT Jabber server name (defined in array "$_prog_irsimSrv")..
$irsimJabAcct1 = "YourPersonalIRSIMjabberAcctName1";		// IRSIM "my" jabber server account name 1.
$irsimJabAcct2 = "YourPersonalIRSIMjabberAcctName1";		// IRSIM "my" jabber server account name 2 (optional).
$irsimJabAcct1pass = $_sysDBuser1LoginPass;			// IRSIM account 1 password.
$irsimJabAcct2pass = $_sysDBuser1LoginPass;			// IRSIM account 2 password.
//
$_prog_irsimResource = "InvisionixIRSIM";			// IM account Jaber resource name.
$_prog_irsimPort = 5222;					// IM server port number using.
$_prog_irsimDEBUG = FALSE;					// IRSIM debug mode on/off switch.
$_prog_irsimLogswitch = FALSE;					// IM transaction logging on/off switch.
$_prog_irsimFilename = 'logfile.txt';				// IM transaction logging file name.
$_prog_irsimDEFAULTusername = $irsimJabAcct1;			// IRSIM DEFAULT account name  on jabber servers.
$_prog_irsimDEFAULTuserPass = $irsimJabAcct1pass;		// IRSIM DEFAULT account password on jabber servers.
$_prog_irsimDEFAULTsrvr = $irsimDefaultHostLabel;		// IRSIM DEFAULT Jabber server name (defined in array "$_prog_irsimSrv")..

// =================================================================================

// /////////////////////////////// //
//  The specific program related   //
//  settings section starts here.  //
// /////////////////////////////// //
//  NOTE: There is little need to
//  make changes in the area below
//  unless you are adding a new
//  program to the IRSR and wish
//  to set its initialization and
//  configuration values globally.
//

//
// FileMgr program (fmgr_).
// Directory paths.
//
$fmgr_RootPath = $_sysRootPath;


//
// Notes program (notes_).
//
$notes_thehost= $_sysDBhost1;
$notes_mydatabase= $_sysDBname;
$notes_login= $_sysDBuser1Login;
$notes_pass = $_sysDBuser1LoginPass;


//
// Bookmarker program (bkmrkr_).
//
$bkmrkr_host = $_sysDBhost1;				// MySQL Host
$bkmrkr_DBname = $_sysDBname;				// Database name
$bkmrkr_DBuserLogin = $_sysDBuser1Login;		// MySQL Username
$bkmrkr_DBuserLoginPass = $_sysDBuser1LoginPass;	// MySQL User Password
$bkmrkr_AdminLogin = $_sysAdminLogin;			// Administrator username for WEB - based editing interface
$bkmrkr_AdminPass = $_sysAdminPass;			// Administrator password for WEB - based editing interface


//
// Net2FTP program (n2f_).
//

// The URL of net2ftp on the website
//
$n2f_relativePath = $_prog_n2fRelativePath;		// Net2FTP relative URL path.
$n2f_locationURL = $_sysRootURL . $n2f_relativePath;	// Set correct absolute URL path.


// Enter email address
//
$n2f_emailAddr = $_sysMainEmailAddr;


//
// Database settings, used to log
// the actions of the users (no
// password logging)
//

// If you want to enable net2ftp
// logging (see below), set to "yes".
// NOTE: Make sure to create the fields
//       in the database first.
//
$n2f_doLogging = $_prog_n2fLogging;

// MySQL DB settings
$n2f_DBhostName   = $_sysDBhost1;
$n2f_DBhostLoginAcct = $_sysDBname;
$n2f_DBuserLogin = $_sysDBuser1Login;
$n2f_DBuserPass = $_sysDBuser1LoginPass;


//
// IRSIM program (irsim_).
//
//
require "$_prog_irsimJabSrvrFileLoc";			// The jabber servers' list and definitions.
//
$irsim_host = $_sysDBhost1;				// DB host name
$irsim_db = $_sysDBname;				// Database name.
$irsim_user = $_sysDBuser1Login;			// DB user name.
$irsim_pass = $_sysDBuser1LoginPass;			// DB user password.
//
$irsim_server = $_prog_irsimJabberServer;		// IM Jabber server name.
$irsim_port = $_prog_irsimPort;				// IM server port number using.
$irsim_username = $_prog_irsimDEFAULTusername;		// IRSIM DEFAULT account name.
$irsim_password	= $_prog_irsimDEFAULTuserPass;		// IRSIM DEFAULT account password.
$irsim_resource	= $_prog_irsimResource;			// IM account Jaber resource name.
$irsim_logswitch = $_prog_irsimLogswitch;		// ????? IM transaction logging on/off switch.
$irsim_filename = $_prog_irsimFilename;			// ???? IM transaction logging file name.


//
// Poppawid program (powid_).
//
global  $powid_host, $powid_DBname, $powid_DBuserLogin, $powid_DBuserLoginPass, $powid_dbPrefix;

$powid_dbPrefix = "pop_";				// DB tables prefix.
							// Leave prefix blank if upgrading (or you will have to manually change)

$powid_host = $_sysDBhost1;				// MySQL Host
$powid_DBname = $_sysDBname;				// Database name
$powid_DBuserLogin = $_sysDBuser1Login;			// MySQL Username
$powid_DBuserLoginPass = $_sysDBuser1LoginPass;		// MySQL User Password
$powid_AdminLogin = $_sysAdminLogin;			// Administrator username
$powid_AdminPass = $_sysAdminPass;			// Administrator password


//
// phpMyAdmin program (pma_).
//
$pma_absURIpath = $_prog_pmaURIpath;			// PhpMyAdmin URI path.
$pma_AdminLogin = $_sysAdminLogin;			// Administrator username
$pma_AdminPass = $_sysAdminPass;			// Administrator password
$pma_hostList = $_sysDBhostList;			// Login info array for entring into the databases.


//
// Waboo program (wab_).
//
global $wab_host;

$wab_siteURL = $_sysRootURL;				// URL of your wa-boo. have to be set
$wab_emailServerPref = $_prog_wabEmailServerPref;	// Email server domain prefix value: "email" or "mail" ("email" is  for french provider online.fr, "mail" for classical providers)
$wab_emailDomainName = $_prog_wabEmailDomainName;       // Please set your_domain.com
switch ($_sysType) {					// Define waboo's system dependent variables.
	case "unix_OR_linux": $wab_hostType = "nix";  break;	// Host site system type Waboo value: "win" for windows, "nix" for unixes
	case "windows":       $wab_hostType = "win";  break;	// Host site system type Waboo value: "win" for windows, "nix" for unixes
	default:
		echo "<BR><b>ERROR:</b> A host of type '<b>" . $_sysType . "</b>' was detected in a SYSTEM includes file.";
		echo "<BR>Since that type is not being handled, 'Waboo' may run into unknown problems!<BR>\n"; 
	break;
}

$wab_host = $_sysDBhost1;				// MySQL Host
$wab_DBname = $_sysDBname;				// Database name
$wab_DBuserLogin = $_sysDBuser1Login;			// MySQL Username
$wab_DBuserLoginPass = $_sysDBuser1LoginPass;		// MySQL User Password


//
// WebEdit program (webe_).
//
$webe_user = $_sysAdminLogin;
$webe_pass = $_sysAdminPass;


//
// File-ExploreIt program (expIt_).
//
$expIt_pass = $_sysAdminPass;

?>
