<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

#
# Utility functions.
#

require_once("config.php");

if (isset($_COOKIE["phpExploreIt_login"]))
	if ($_COOKIE["phpExploreIt_login"] != $expPrefPass)
		header ("location: login.php");

function loadDir ($path)
{
	global $files, $dirs, $total_files, $total_dirs;
	$files = array();
	$dirs = array();
	$total_files = 0;
	$total_dirs = 0;

	if ($handle = opendir($path))
	{
		while (false !== ($file = readdir($handle)))
		{ 
			if ($file != "." && $file != "..")
			{

				if ((getenv('windir')) && (is_file($path."\\".$file)))
				{
					if (is_file($path."\\".$file))
					{
						$files[] = $file;
						$total_files++;
					} else {
						$dirs[] = $file;
						$total_dirs++;
					}
				} else {
					if (is_file($path."/".$file))
					{
						$files[] = $file;
						$total_files++;
					} else {
						$dirs[] = $file;
						$total_dirs++;
					}
				}
			}
		}
	} else {
		return 0;
	}

	if (!$expSortOrder)
	{
		sort ($files);
		sort ($dirs);
	} else {
		rsort ($files);
		rsort ($dirs);
	}

	closedir($handle);
	return 1;
}

/* Incomplete function, left it for next versions.
function searchObj ($query,$path,$type)
{
	global $found;
	$found = array();
	if (loadDir($path))
	{
		echo $dirs[1];
		for ($x = 0; $dirs[$x]; $x++)
		{
			if (eregi($query, $dirs[$x]))
			{
				$found[] = $dirs[$x];
				echo "888";
			}
		}
		for ($x = 0; $files[$x]; $x++)
		{
			if (eregi($query, $files[$x]))
			{
				$found[] = $files[$x];
				echo "9999";
			}
		}
	}
	echo $found[0];
	return 1;
}*/

function getPermissions ($file)
{
	$stats = stat($file);

	$_perms = $stats[2] & 511;
	$_full = 256;
	$_perm = "";
	$rxw = array('r','x','w');
	
	for ($y = 9 ; $y > 0 ; $y--) { 
		if (($_perms) & ($_full))
		{
			$_perm .= $rxw[$y % 3];
		}
		$_full = $_full >> 1;
	}
	return $_perm;
}

function getOwner ($file)
{
	$stats = stat($file);
	if (getenv('windir'))
		return "n/a";
	else
		return $stats[4];
}

function getGroup ($file)
{
	$stats = stat($file);
	if (getenv('windir'))
		return "n/a";
	else
		return $stats[5];
}

function getSize ($file)
{
	$stats = stat($file);
	return getRealSize($stats[7]);
}

function getModified ($file)
{
	$stats = stat($file);
	return date('M d, Y h:s',$stats[10]);
}

function getRealSize ($filesize)
{
	if (($filesize / 1024) < 1024)
		return round (($filesize / 1024),2) . " kb";
	elseif ((($filesize / 1024) / 1024) < 1024)
		return round ((($filesize / 1024) / 1024),2) . " mb";
	else
		return round (((($filesize / 1024) / 1024) / 1024),2) . " gb";
}

function getFileOptions ($file)
{

}

function delObject ($object) {
	if (file_exists($object))
	{
		chmod($object,0777);
		if (is_dir($object))
		{
			$handle = opendir($object); 
			while($objectname = readdir($handle))
				if ($objectname != "." && $objectname != "..")
					delObject($object."/".$objectname);
			closedir($handle);
			rmdir($object);
		} else {
			unlink($object);
		}
	}
}

function upload ($filedir,$source,$source_name,$up_flag,$lastname)
{
	if (!file_exists($filedir))
		mkdir($filedir,0777);

	@chmod($filedir,0777);
	if (!$lastname)
		$lastname=$source_name;
	if (file_exists("$filedir/$lastname"))
	{
		if ($up_flag=="y")
		{
			@unlink($filedir/$lastname);
			@move_uploaded_file($source,"$filedir/$lastname");
			echo "$source_name OK<br>";
		} else {
			echo "$source_name ...<br>";
		}
	} else {
		@move_uploaded_file($source,"$filedir/$lastname");
		echo "$source_name OK<br>"; 
	}
} 


function getFileName ($file)
{
	$strlen = strlen($file); 
	$retfile = "";
	while ($strlen > 0)
	{
		$_g = substr(substr($file, $strlen, strlen($file)), 0, 1);
		if (($_g == "\\") or ($_g == "/"))
			break;

		$retfile = substr($file, $strlen, strlen($file)); 
		$strlen = $strlen-1; 
	} 
	return $retfile;
}

function getExtension ($file)
{
	$_file = trim ("$file");

        $getpos = strrpos($_file,"."); 
        if (!$getpos)
		return "";

        $calc = strlen($_file) - $getpos; 
        return substr($_file, $getpos+1, $calc);
}

function getIcon ($file)
{
	global $_fedit, $_finfo, $_ftype;
	$_fedit = "";
	$_finfo = "";
	$ext = getExtension ($file);

	if (isset($ext))
	{
		$_icon = "default.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Default";
	}

	if (eregi("exe|bin|msi|dll", $ext))
	{
		$_icon = "bin.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Binary";
	}

	if (eregi("tar", $ext))
	{
		$_icon = "tar.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Tarball";
	}

	if (eregi("doc|rtf|wri", $ext))
	{
		$_icon = "doc.gif";
		$_finfo = 1;
		$_fedit = 0; // I am disabling editing for this filetype because it uses too much resources and PHP does not interpret word .doc files well.
		$_ftype = "Document";
	}

	if (eregi("pdf", $ext))
	{
		$_icon = "pdf.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Adobe Acrobat";
	}

	if (eregi("jar|java|jtk|class|js", $ext))
	{
		$_icon = "js.gif";
		$_finfo = 1;
		$_fedit = 1;
		$_ftype = "Java";
	}

	if (eregi("jpg|png|bmp|gif|tif|tga|peg|tiff|psd|jpc|jp2|jpx|swc|jfif|art|ico", $ext))
	{
		$_icon = "gif.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Image";
	}

	if (eregi("mpg|avi|divx|mpeg|mov|ram|qt|wmv|mpe|asf", $ext))
	{
		$_icon = "mov.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Movie";
	}

	if (eregi("mp3|mp2|ogg|wav|mpc|flac|ape|aac|mp4|aif|aiff|au|la|mid|midi|vqf|mod|wma|voc|mp+|mpp|bonk|ofr|shn|lqt|mpga|ra|pac|wv|mka|mp1|spc|rmjb|rm", $ext))
	{
		$_icon = "wav.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Audio";
	}

	if (eregi("txt|md5|sfv|log|cpp|m3u|cc|cp", $ext))
	{
		$_icon = "txt.gif";
		$_finfo = 1;
		$_fedit = 1;
		$_ftype = "Text Document";
	}

	if (eregi("html|htm|asp|css|shtml|pl|swf|cgi|mht|mhtml", $ext))
	{
		$_icon = "htm.gif";
		$_finfo = 1;
		$_fedit = 1;
		$_ftype = "HTML";
	}

	if (eregi("php|phps|phtml|php3", $ext))
	{
		$_icon = "php.gif";
		$_finfo = 1;
		$_fedit = 1;
		$_ftype = "PHP/HTML";
	}

	if (eregi("cmd", $ext))
	{
		$_icon = "cmd.gif";
		$_fedit = 0;
		$_finfo = 1;
		$_ftype = "Command";
	}

	if (eregi("cls", $ext))
	{
		$_icon = "cls.gif";
		$_fedit = 0;
		$_finfo = 1;
		$_ftype = "Unknown";
	}

	if (eregi("inc", $ext))
	{
		$_icon = "inc.gif";
		$_finfo = 1;
		$_fedit = 1;
		$_ftype = "Include";
	}

	if (eregi("ini|cfg|inf|nfo", $ext))
	{
		$_icon = "inf.gif";
		$_fedit = 1;
		$_finfo = 1;
		$_ftype = "System Configs";
	}

	if (eregi("xml", $ext))
	{
		$_icon = "xml.gif";
		$_fedit = 1;
		$_finfo = 1;
		$_ftype = "XML";
	}

	if (eregi("zip|tgz|gz|rar|bz2|7z|ace|sit|arc|taz", $ext))
	{
		$_icon = "zip.gif";
		$_finfo = 1;
		$_fedit = 0;
		$_ftype = "Compressed";
	}

	if ((!isset($_icon)) or (!is_file("./images/extensions/$_icon")))
	{
		$ext = "default.gif";
		$_finfo = 1;
		$_fedit = 0;
	}

	return $_icon;
}
?>