<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
# Copyright information: Tom Gries, v1.0 - 2002/01/17                        #
# The newest Version is available at:                                        #
#   www.xsurf.net/download/index.htm?&infotype=Download&category=Allgemein.  #
# ========================================================================== #
#

//ir
//ir Perform IRSR system page header functions here.
//ir
$globalProgsFileRelativePath = "/programs/includes/programs.inc.php";	// Relative path to the system's global programs include file - Unix.
//$globalProgsFileRelativePath = "\programs\includes\programs.inc.php";	// Relative path to the system's global programs include file - Windows.
$globalBaseProgsFilePath = getenv("DOCUMENT_ROOT");			// Obtain the base root path from the ISP's system.
$globalProgsFilePath = $globalBaseProgsFilePath . $globalProgsFileRelativePath;	// Create the system's global programs include file path.
require_once	($globalProgsFilePath);				// System's global programs include file.

$globalDDmenuIncludeFilePath = $globalBaseProgsFilePath . $_sysGlobalDDmenuIncludeFileRelativePath;		// Create the system's global program dropdown menu include file path.
$globalDDmenuCssIncludeFilePath = $globalBaseProgsFilePath . $_sysGlobalDDmenuCssIncludeFileRelativePath;	// Create the system's global program dropdown menu CSS include file path.

require_once	($_sysPageHeaderDefault);		// Default page header file.
if ($passed != "passedThrough") {			// First time through here?
	$passed = "passedThrough";			// Flag as "passed through here" already.
	if (!$session){					// Page not authorized for this user?
		header("Location: $_sysRootURL");	// Go back to the login page.
	}
}

disableBadKeys();		// Disable undesireable key and mouse requests.

print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">';
print '<HTML>';
print '<head>';
print '<title>Grep utility</title>';
print '</head>';

print '<BODY background="' . $_sysBackgroundDefault . '" topmargin="0" target="_top">';

require_once ($globalDDmenuCssIncludeFilePath);		// Global program dropdown menu CSS include file.
require_once ($globalDDmenuIncludeFilePath);		// Global program dropdown menu include file.


// ----------------------------------------------------------------------------------------
// Maximum file size of the file to grep.
// ----------------------------------------------------------------------------------------
$length = 1024 * 50;


// ----------------------------------------------------------------------------------------
// Define, which requests are allowed (http, ftp or local). Set TRUE or FALSE.
// ----------------------------------------------------------------------------------------
define("is_enabled_http", TRUE);
define("is_enabled_ftp", FALSE);
define("is_enabled_localfile", FALSE);


// ----------------------------------------------------------------------------------------
// Some cosmetics for the highlighted text.
// ----------------------------------------------------------------------------------------
$highlight_color = "black";
$highlight_fontweight = "bold";
$highlight_background = "yellow";


// ----------------------------------------------------------------------------------------
// NO MOR CONFIGURATION NESSECARY FROM HERE!
// ----------------------------------------------------------------------------------------
define("_HTTP_", "http");
define("_FTP_", "ftp");
define("_LOCAL_", "local");

$script_author_mail = "tom@xsurf.net";
$script_version = "1.0";
$script_header = "<h3 style=\"font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">Grep:</h3>";

if( is_enabled_http ) {
  $status_http = "<font style=\"color:green; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">enabled</font>";
} else {
  $status_http = "<font style=\"color:red; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">disabled</font>";
}

if( is_enabled_ftp ) {
  $status_ftp = "<font style=\"color:green; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">enabled</font>";
} else {
  $status_ftp = "<font style=\"color:red;font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">disabled</font>";
}

if( is_enabled_localfile ) {
  $status_local = "<font style=\"color:green; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">enabled</font>";
} else {
  $status_local = "<font style=\"color:red; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;\">disabled</font>";
}

$arSchema = array(_HTTP_, _FTP_);
$exampleURI = "http://" . $HTTP_SERVER_VARS["SERVER_NAME"] . $HTTP_SERVER_VARS["SCRIPT_NAME"];
$exampleURI_full =  $exampleURI . "?uri=http://" . $HTTP_SERVER_VARS["SERVER_NAME"] . $HTTP_SERVER_VARS["SCRIPT_NAME"] . "&highlight=body";

if( isset($uri) || !empty($uri) ) {
  $uri = urldecode($uri);
}

if( isset($highlight) || !empty($highlight) ) {
  $highlight = urldecode($highlight);
}


function convert2kb($size) {
  if( is_int($size) ) {
    return($size / 1024);
  } else {
    return(FALSE);
  }
} //convert2kb


function is_http($path) {
  if( schema($path) == _HTTP_ ) {
    return(TRUE);
  } else {
    return(FALSE);
  }
} // is_http


function is_ftp($path) {
  if( schema($path) == _FTP_ ) {
    return(TRUE);
  } else {
    return(FALSE);
  }
} // is_ftp


function is_local($path) {
  if( !is_http($path) && !is_ftp($path) ) {
    return(TRUE);
  } else {
    return(FALSE);
  }
} // is_local


function schema($path) {
  global $arSchema;
  
  $schema = split(":", $path);
  $schema = strtolower($schema[0]);

  if( in_array($schema, $arSchema) ) {
    return($schema);
  } else {
    if( !empty($path) ) {
      return(_LOCAL_);
	} else {
      return(FALSE);
	}
  }
} // schema


if( !isset($uri) || empty($uri) ) {

  echo $script_header;
?>


<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
Enter URL, then text to search for, and  press &quot;Submit&quot;.
</p>


<FORM action="<?php echo $PHP_SELF ?>" method="post" target="_top">
<input type="hidden" name="session" value="<?php echo $session; ?>" >
<input type="hidden" name="passed" value="passedThrough">

<table width="800" cellspacing="0" cellpadding="2" border="1">
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="100">uri: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200"><input type="text" name="uri" size="30"></td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="500">&nbsp;<font face="Courier New" size="-1">i.e. <b><?php echo $exampleURI ?></b></font> </td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="100">highlight: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200"><input type="text" name="highlight" size="30"></td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="500">&nbsp;<font face="Courier New" size="-1">i.e. <b>meta</b></font> </td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" colspan="3" width="600" heigth="20">&nbsp;</td>
</tr>
<tr>
    <td width="800" colspan="3" align="center" style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;"><input type="submit" name="submit" value="   Submit   "></td>
</tr>
</table>

</FORM>

<p>&nbsp;</p>

<hr>

<p>&nbsp;</p>

<table width="400" cellspacing="0" cellpadding="2" border="1">
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" colspan="2" width="400" heigth="20"><b>Configuration:</b></td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">HTTP requests: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">&nbsp;<b><?php echo $status_http ?></b></td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">FTP requests: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">&nbsp;<b><?php echo $status_ftp ?></b></td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">Local files: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">&nbsp;<b><?php echo $status_local ?></b></td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" colspan="2" width="400" heigth="20">&nbsp;</td>
</tr>
<tr>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">Max file size: </td>
    <td style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;" width="200">&nbsp;<b><?php echo convert2kb($length) . " kb" ?></b></td>
</tr>
</table>

<p>&nbsp;</p>

<hr>

<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
This script shows the source code of a file. A file can be a regular file (local on the server 
where this script is running) or a remote file (http or ftp). Each type can be enabled seperatly.
</p>

<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
<b>It's highly recommend, not to use the LOCAL directive for security reasons.</b>
</p>

<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
If You grep a remote file, you will only see the output of the server - not the source code of 
a server side script language like PHP.
</p>

<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
You can enter either the file path directly by adding &quot;?uri=path_to_file&quot; to the scriptname 
or by providing the uri and/or text to be highlighted in the fields above. Supported 
arguments are:
</p>

<pre>
uri=&lt;path_to_file&gt;
highlight=&lt;text_to_highlight&gt;
</pre>

<pre>
<p style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;">
Example for direct view:<br>
<a href="<?php echo $exampleURI_full ?>" style="font: 10px; text-align: left;"><?php echo $exampleURI_full ?></a>
</p>
</pre>

<?php
}

if( is_local($uri) && is_enabled_localfile || is_ftp($uri) && is_enabled_ftp || is_http($uri) && is_enabled_http ) {
    if( !($fp = @fopen($uri, "r")) ) {
	  $fp = @fopen($uri . "/", "r");
	}

    if($fp) {
      $source = fread($fp, $length);
  	  $source = "<pre>" . htmlentities($source) . "</pre>";

	  if( isset($highlight) && !empty($highlight) ) {
        $source = eregi_replace("($highlight)", "<font style=\"background-color:$highlight_background; font-weight:$highlight_fontweight; color:$highlight_color;\">\\1</font>", $source);
	  }

      echo $source;
      fclose($fp);

    } else {
    echo "<b>Error: \"" . $uri . "\" does NOT exist!</b><br>\n";
	}

} else {
  if( isset($uri) && !empty($uri) ) {
    echo "<b>Schema \"" . strtoupper(schema($uri)) . "\" is disabled. Source Code will NOT be displayed!</b><br>\n";
  }
}

?>

</BODY>
</HTML>
