<?PHP // -*- coding: utf-8 -*-
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

# ******************************************************
# *                      PhpShell 1.9                  *
# ******************************************************
#  Copyright (C) 2000-2003 Martin Geisler              *
# ******************************************************
#

//ir
//ir Perform IRSR system page header functions here.
//ir
$globalProgsFileRelativePath = "/programs/includes/programs.inc.php";	// Relative path to the system's global programs include file - Unix.
//$globalProgsFileRelativePath = "\programs\includes\programs.inc.php";	// Relative path to the system's global programs include file - Windows.
$globalBaseProgsFilePath = getenv("DOCUMENT_ROOT");			// Obtain the base root path from the ISP's system.
$globalProgsFilePath = $globalBaseProgsFilePath . $globalProgsFileRelativePath;	// Create the system's global programs include file path.
require_once	($globalProgsFilePath);				// System's global programs include file.

$globalDDmenuIncludeFilePath = $globalBaseProgsFilePath . $_sysGlobalDDmenuIncludeFileRelativePath;		// Create the system's global program dropdown menu include file path.
$globalDDmenuCssIncludeFilePath = $globalBaseProgsFilePath . $_sysGlobalDDmenuCssIncludeFileRelativePath;	// Create the system's global program dropdown menu CSS include file path.

require_once	($_sysPageHeaderDefault);		// Default page header file.
if ($passed != "passedThrough") {			// First time through here?
	$stderr = "checked";									// Start stderr as "on".
	$passed = "passedThrough";			// Flag as "passed through here" already.
	if (!$session){					// Page not authorized for this user?
		header("Location: $_sysRootURL");	// Go back to the login page.
	}
}

disableBadKeys();		// Disable undesireable key and mouse requests.

header('Content-Type: text/html; charset=UTF-8');
//
// Since most installations still operate with short_open_tag enabled,
// we have to echo this string from within PHP:
//
echo '<?xml version="1.0" encoding="UTF-8"?>' . "\n"; ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<HTML xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<?PHP
print '<HEAD>';
print '<title>PhpShell Utility</title>';
print '</HEAD>';


print '<BODY background="' . $_sysBackgroundDefault . '" onload="document.forms[0].command.focus();" topmargin="0" target="_top">';

require_once ($globalDDmenuCssIncludeFilePath);		// Global program dropdown menu CSS include file.
require_once ($globalDDmenuIncludeFilePath);		// Global program dropdown menu include file.

$first_dir = getenv("DOCUMENT_ROOT");			// Set the initial working directory level.
$work_dir = empty($_REQUEST['work_dir']) ? $first_dir : $_REQUEST['work_dir'];
$command  = empty($_REQUEST['command'])  ? '' : $_REQUEST['command'];

/* First we check if there has been asked for a working directory. */
if ($work_dir != '') {
  /* A workdir has been asked for */
  if ($command != '') {
    if (ereg('^[[:blank:]]*cd[[:blank:]]+([^;]+)$', $command, $regs)) {
      /* We try and match a cd command. */
      if ($regs[1][0] == '/') {
        $new_dir = $regs[1]; // 'cd /something/...'
      } else {
        $new_dir = $work_dir . '/' . $regs[1]; // 'cd somedir/...'
        $new_dir = str_replace('/./', '/', $new_dir);
        $new_dir = preg_replace('|/?[^/]*/\.\.|', '$1', $new_dir);
      }
      if (file_exists($new_dir) && is_dir($new_dir)) {
        $work_dir = $new_dir;
      }
      $command = '';
    }
  }
}

if ($work_dir != '' && file_exists($work_dir) && is_dir($work_dir)) {
  /* We change directory to that dir: */
  chdir($work_dir);
}

/* We now update $work_dir to avoid things like '/foo/../bar': */
if ($work_dir == '') $work_dir = getcwd();


echo '<form method="POST" action="' . $_SERVER['PHP_SELF'] . '" target="_top">';
echo '<input type="hidden" name="session" value="' . $session . '" >';
echo '<input type="hidden" name="passed" value="passedThrough">';
echo '<input type="hidden" name="stderr">';

echo '<fieldset><legend>Input</legend>';
echo '<p><u>path:</u><b>&nbsp;&nbsp';

$work_dir_splitted = explode('/', substr($work_dir, 1));

echo '<a href="' . $_SERVER['PHP_SELF'] . '?session=' . $session . '&passed=' . $passed . '&stderr=' . $stderr . '&work_dir=/">root</a>/';

if (!empty($work_dir_splitted[0])) {
  $path = '';
  for ($i = 0; $i < count($work_dir_splitted); $i++) {
    $path .= '/' . $work_dir_splitted[$i];
    printf('<a href="%s&work_dir=%s">%s</a>/',
           $_SERVER['PHP_SELF']  . '?session=' . $session . '&passed=' . $passed . '&stderr=' . $stderr,
           urlencode($path),
           $work_dir_splitted[$i]);
  }
}

echo '</b></p>';
echo '<p>';

// Assemble the checkbox input field.
$chkbx = '<input type="checkbox" name="stderr"';
if ($stderr) $chkbx .= 'checked="checked"';
$chkbx .= '/> << <code>STDERR</code> on/off! ';
echo $chkbx;

echo '<input name="submit_btn" type="submit" value=" GO " />';

echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp';
echo 'select:';
echo '<select name="work_dir" onchange="this.form.submit()">';


/* Now we make a list of the directories. */
$dir_handle = opendir($work_dir);
/* We store the output so that we can sort it later: */
$options = array();
/* Run through all the files and directories to find the dirs. */
while ($dir = readdir($dir_handle)) {
  if (is_dir($dir)) {
    if ($dir == '.') {
      $options['.'] = "<option value=\"$work_dir\" selected=\"selected\">subdirectories</option>";
    } elseif ($dir == '..') {
      /* We have found the parent dir. We must be carefull if the
       * parent directory is the root directory (/). */
      if (strlen($work_dir) == 1) {
	/* work_dir is only 1 charecter - it can only be / There's no
         * parent directory then. */
      } elseif (strrpos($work_dir, '/') == 0) {
	/* The last / in work_dir were the first charecter.  This
         * means that we have a top-level directory eg. /bin or /home
         * etc... */
        $options['..'] = "<option value=\"/\">Parent Directory</option>";
      } else {
        /* We do a little bit of string-manipulation to find the parent
         * directory... Trust me - it works :-) */
        $options['..'] = "<option value=\"" .
          strrev(substr(strstr(strrev($work_dir), "/"), 1)) .
          "\">Parent Directory</option>";
      }
    } else {
      if ($work_dir == '/') {
	$options[$dir] = "<option value=\"/$dir\">$dir</option>";
      } else {
	$options[$dir] = "<option value=\"$work_dir/$dir\">$dir</option>";
      }
    }
  }
}
closedir($dir_handle);

ksort($options);

echo implode("\n", $options);

echo '</select>';
echo '</p>';

echo '<p>Command: <input type="text" name="command" size="60" /></p>';

echo '</fieldset>';

echo '<fieldset><legend>Output</legend>';

echo '<p><textarea cols="70" rows="15" readonly="readonly">';

if (!empty($command)) {
  if ($command == 'ls') {
    /* ls looks much better with ' -F', IMHO. */
    $command .= ' -F';
  }
  if ($stderr) {
    $tmpfile = tempnam('/tmp', 'phpshell');
    $command .= " 1> $tmpfile 2>&1; cat $tmpfile; rm $tmpfile";
  }
  echo htmlspecialchars(shell_exec($command), ENT_COMPAT, 'UTF-8');
}

echo '</textarea></p>';

echo '</fieldset>';
echo '</form>';

echo '</body>';
echo '</html>';

?>
