<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

# ############################################## #
#                                                #
#  This file contains this IRSR  site's global   #
#  configuration variables, and values.          #
#  These constants, variables, and arrays are    #
#  used for SYSTEM initialization and operation. #
#                                                #
# ############################################## #
#                                                #

// ////////////////////////////// //
//  System's settings (_sys...).  //
// ////////////////////////////// //
//
// NOTE: Modify the values in the
// section right below to effect 
// changes pertaining to your
// specific needs.
//


//
// Site's identity definitions.
//
$_sysName = "Invisionix Roaming System";		// Descriptive name of the overall system.
$_sysLocation = "Remote";				// Location of the system (=> Local, Remote, Central, Foundry).
$_sysVersionPrefix = "v";				// System version number prefix.
$_sysVersionNum = "0.2";				// System version number.
$_sysVersionPostfix = "";				// System version number postfix.
$_sysCopyright = "(c) 2003-" . date("Y");		// System copyright notice.
$_sysCompany = "Invisionix Systems";			// System's company name.

//
// Site's absolute names, variables, and paths.
//
$_sysRootURLdefault = "http://someSubdomain.YourDomain.com";	// Non-secure URL for the IRSR host.
$_sysRootURIpath = "http://websiteISPsubdomain.websiteISPdomain.com";	// Non-secure URI root path.
$_sysRootURLsecure = "https://someSubdomain.YourDomain.com";	// Secure URL for the IRSR host.
$_sysRootURLhost2 = "http://someSubdomain.YourDomain.com";	// URL for an IRSC-externals host.
$_sysCOMwebsiteURL = "http://www.YourDomain.com";	// URL to the public information ".com" website.
$_sysORGwebsiteURL = "http://www.YourDomain.org";	// URL to the public information ".org" website.
$_sysNETwebsiteURL = "http://www.YourDomain.net";	// URL to the public information ".net" website.
$_sysBIZwebsiteURL = "http://www.YourDomain.biz";	// URL to the public information ".biz" website.
$_sysMainEmailAddr = "info@YourDomain.org";		// Main general purpose e-mail address.
$_sysSkinsBkgrndDefaultFile = "binderbackground.gif";	// Default background file (in the system subdirectories.)
$_sysSkinsBkgrndRtDefaultFile = "binderbackground-right.gif";	// Default right-side background file (in the system subdirectories.)
//
$_sysRootURL = $_sysRootURLdefault;			// Assign secure/insecure type of URL for this session.
$_sysInvisionixWebsiteURL = $_sysORGwebsiteURL ;	// URL to the currently targeted Public information website.

//
// Site's Administrator's settings.
//
$_sysAdminLogin = "admin";				// Administrator's login account name.
$_sysPreregDBpass = "PasswordYouCreatedForYourMySQLdatabase"; // Your initial host DataBase password. Pre-IRSR DB registration (Change this to "" after you register an IRSR admin account/pass.)
$_sysAdminEmailAddr = "admin@YourDomain.org";		// Main general purpose e-mail address.
$_sysAuthenDir = getenv("DOCUMENT_ROOT") . '/authenticate/'; // Authenticate directory's relative path.
$_sysPaWordfName = '.htpasswd';				// Authenticate's '.htpassword' file name.
$_sysPaWordPthName = $_sysAuthenDir . $_sysPaWordfName;	// Authenticate's '.htpassword' file name PATH.
$_sysPaFileChrFlr = 10;					// Upper limit (# of characters) of pre-registration '.htpassword' file in 'Autenticate' dir.
$_sysAdminPass = (filesize($_sysPaWordPthName) < $_sysPaFileChrFlr) ? $_sysPreregDBpass : genP(); // Administrator's password.

//
// Site's session global settings.
//
$_sysSessionIDlen = 35;				// Length of generated session ID values.
$_sysSessionPageExpire = (time() - 1200);	// Length of generated session ID values.
$_sysSessionDefaultCorpDivision = 'YourCompanyDivision'; // Default Session corporate division designation.
$_sysSessionDefaultAccess = '100';		// Default Session Access permitted value (0-100, with 0 not access, 100 full access.).

//
// Site's execution control parameters.
//
$_sysScriptTimeout = 300;			// Maximum seconds a PHP script is allowed to run.
$_sysDEBUG = FALSE;				// System debug mode on/off switch.
$_sysFileProtectionMechanism = 'internal';	// => 'internal' (user has control). => 'external' (ISP has control).
$_sysLoginPassEncEnable = TRUE;			// Login pass encryption on/off switch.
$_sysLoginAlgRand = rand(1,9); 			// Login pass encryption algorithm seed value (from 1-9).
$_sysLoginMainCharSet = '\\\N$%^[O1&PrQ(./T~=`"CDE|F!G@SUV-Whigj}:<pHB*#8ueawvXx>?o]\\\',f34L5Z90qRlnIJ)_+{st6k7cbdAy;zKmM2Y'; // Login entrance pass enctyption character set.

//
// IRSR servers neighborhood.
//
$_sysThisServer_index = 1;			// The default IRSR/IRSC we are using here.
$_sysRemoteServerList =  array(			// Define IRSR/IRSC server-entring parameters and description values (index must start at 1).
			1 => array(		// 1st IRSR server.
				"ServerName" => "someSubdomain.someDomain.com",	// IRSR 1 server's name.
				"ServerLoginName" => $_sysAdminLogin,	// IRSR 1 login user name.
				"ServerLoginPass" => $_sysAdminPass,	// IRSR 1 login user password.
				"ServerHostSysName" => "hostName.com",	// IRSR 1 server's host system name.
				"Server_Label" => "IRSR 1"		// IRSR 1 server verbose description.
				),
			2 => array(		// 2nd IRSR server.
				"ServerName" => "someSubdomain.someDomain.com",	// IRSR 2 server's name.
				"ServerLoginName" => $_sysAdminLogin,	// IRSR 2 login user name.
				"ServerLoginPass" => $_sysAdminPass,	// IRSR 2 login user password.
				"ServerHostSysName" => "hostName.com",	// IRSR 2 server's host system name.
				"Server_Label" => "IRSR 2"		// IRSR 2 server verbose description.
				),
			3 => array(		// 3rd IRSR server.
				"ServerName" => "someSubdomain.someDomain.com", // IRSR 3 server's name.
				"ServerLoginName" => $_sysAdminLogin,	// IRSR 3 login user name.
				"ServerLoginPass" => $_sysAdminPass,	// IRSR 3 login user password.
				"ServerHostSysName" => "hostName.com",	// IRSR 3 server's host system name.
				"Server_Label" => "IRSR 3"		// IRSR 3 server verbose description.
				),
			4 => array(		// An IRSC server.
				"ServerName" => "someSubdomain.someDomain.com", // IRSC server's name.
				"ServerLoginName" => $_sysAdminLogin,	// IRSC login user name.
				"ServerLoginPass" => $_sysAdminPass,	// IRSC login user password.
				"ServerHostSysName" => "hostName.com",	// IRSC server's host system name.
				"Server_Label" => "IRSC"		// IRSR server verbose description.
				),
		);

//
// Database login settings.
//
$_sysPrimaryDB_index = 1;			// Primary database index into the $_sysDBhostList.
$_sysDBhostList =  array(			// Define phpMyAdmin DB-entring parameters (index must start at 1).
			1 => array(		// 1st DB (index must be 1).
				"hostName" => "dbSubdomain.dbDomain.net",	// DB host (server) name.
				"DBname" => "dbName",			// DB name.
				"DBuserLogin" => "dbUserLoginName",	// DB Login account.
				"DBuserLoginPass" => $_sysAdminPass,	// DB login account password.
				"DB_Label" => "someName DB"		// DB verbose description.
				),
			2 => array(		// 2nd DB
				"hostName" => "dbSubdomain.dbDomain.net",	// DB host (server) name.
				"DBname" => "dbName",			// DB name.
				"DBuserLogin" => "dbUserLoginName",	// DB Login account.
				"DBuserLoginPass" => $_sysAdminPass,	// DB login account password.
				"DB_Label" => "someName DB"		// DB verbose description.
				),
			3 => array(		// 3rd DB
				"hostName" => "dbSubdomain.dbDomain.net",	// DB host (server) name.
				"DBname" => "dbName",			// DB name.
				"DBuserLogin" => "dbUserLoginName",	// DB Login account.
				"DBuserLoginPass" => $_sysAdminPass,	// DB login account password.
				"DB_Label" => "someName DB"		// DB verbose description
				),
//ir			N => array(		// Nth DB
//ir				"hostName" => "dbSubdomain.dbDomain.net",	// DB host (server) name.
//ir				"DBname" => "dbName",			// DB name.
//ir				"DBuserLogin" => "someDbUserLoginName",	// DB Login account.
//ir				"DBuserLoginPass" => "somePassword",	// DB login account password.
//ir				"DB_Label" => "someName DB"		// DB verbose description
//ir				),
		);
?>
