<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#  Thanks to http://www.sitepoint.com/article/619                            #
#  and/or http://kristof.f2o.org/tut/php/browser.php                         #
#  and Ilon Dalon at id@invisionix.org                                       #
# ========================================================================== #
#                                                                            #

# *******************************************************
#
#     Functions used by various system-wide routines.
#
# *******************************************************
#

function _inAgent($agent){	// Get browser variables.
	global $thestring, $place;
	$thestring = strtolower($agent);
	$place = strpos(strtolower($_SERVER['HTTP_USER_AGENT']), $thestring) + 1;
	return eregi($agent, $_SERVER['HTTP_USER_AGENT']);
}

function _inServer($agent){	// Get server variables.
	global $thestring, $place;
	$thestring = strtolower($agent);
	$place = strpos(strtolower(getenv("SERVER_SOFTWARE")), $thestring) + 1;
	return eregi($agent, getenv("SERVER_SOFTWARE"));
}


//
// Get browser data.
//
function _getBrowser() {
	global $thestring, $place, $version;
	if (_inAgent('konqueror')) $browser = 'Konqueror';
	else if (_inAgent('w3c_validator')) $browser = 'W3C_Validator';
	else if (_inAgent('jigsaw')){
		$browser = 'W3C_CSS_Validator';
		$version = substr($_SERVER['HTTP_USER_AGENT'], $place + strlen($thestring), 6);
	}
	else if (_inAgent('googlebot')) $browser = 'Googlebot';
	else if (_inAgent('lynx'))$browser = 'Lynx';
	else if (_inAgent('omniweb'))$browser = 'OmniWeb';
	else if (_inAgent('opera'))$browser = 'Opera';
	else if (_inAgent('webtv'))$browser = 'WebTV';
	else if (_inAgent('icab'))$browser = 'iCab';
	else if (_inAgent('safari'))$browser = 'Safari';
	else if (_inAgent('msie'))$browser = 'Internet Explorer';
	else if (!_inAgent('compatible')){
		$browser = 'Netscape Navigator';
		$version = substr($_SERVER['HTTP_USER_AGENT'], 8, 4);
	}
	else $browser = 'unknown';

	return $browser;
}


//
// Get browser's OS.
//
function _getBrowserOS() {
	global $thestring, $place, $version;
	if (!isset($version))
		$version = substr($_SERVER['HTTP_USER_AGENT'], $place + strlen($thestring), 4);
	$version = ereg_replace('[^.0-9]', '', $version);

	if (_inAgent('linux')) $os = 'linux';
	else if (_inAgent('unix')) $os = 'unix';
	else if (_inAgent('x11')) $os = 'unix';
	else if (_inAgent('windows')) $os = 'windows';
	else if (_inAgent('win')) $os = 'windows';
	else if (_inAgent('macintosh')) $os = 'macintosh';
	else if (_inAgent('mac')) $os = 'macintosh';
	else if (_inAgent('konqueror')) $os = 'linux';
	else $os = 'unknown';

	return $os;
}

//
// Get the server's (host) OS.
//
function _getHostOS() {
	global $thestring, $place, $version;
	if (!isset($version))
		$version = substr($_SERVER['HTTP_USER_AGENT'], $place + strlen($thestring), 4);
	$version = ereg_replace('[^.0-9]', '', $version);

	if (_inServer('linux')) $os = 'linux';
	if (_inServer('unix')) $os = 'unix';
	else if (_inServer('x11')) $os = 'unix';
	else if (_inServer('windows')) $os = 'windows';
	else if (_inServer('win')) $os = 'windows';
	else if (_inServer('macintosh')) $os = 'macintosh';
	else if (_inServer('mac')) $os = 'macintosh';
	else if (_inServer('konqueror')) $os = 'linux';
	else $os = 'unknown';

	return $os;
}


//
// Determine if Browser has Javascript.
// Can return the JavaScript version number, when JSVer() is called.
//
function checkforJavaScript() {
	print	'<!--';
	print   '<SCRIPT Language="JavaScript">		function JSVer() { return "1.0" } </SCRIPT>';
	print   '<SCRIPT Language="JavaScript1.1">	function JSVer() { return "1.1" } </SCRIPT>';
	print   '<SCRIPT Language="JavaScript1.2">	function JSVer() { return "1.2" } </SCRIPT>';
	print   '<SCRIPT Language="JavaScript1.3">	function JSVer() { return "1.3" } </SCRIPT>';
	print   '<SCRIPT Language="JavaScript1.4">	function JSVer() { return "1.4" } </SCRIPT>';

	print   '<SCRIPT Language="JavaScript1.5">	function JSVer() { return "1.5" } </SCRIPT>';
	print   '<SCRIPT Language="JavaScript1.6">	function JSVer() { return "1.6" } </SCRIPT>';
	print   '<NOSCRIPT>';
	print   '	<CENTER><BR><H3><B>PROBLEM: No JavaScript detected in browser!</B></H3></CENTER><BR>';
	print   '</NOSCRIPT>';
	print	'//-->';
}

//
// Disable undesireable user key and mouse requests.
//
function disableBadKeys() {
	//
	// Disable several keys and right mouse key.
	//
	print "<script language='javascript'>\n";
	print "<!--\n";

	print "document.oncontextmenu = disrightmousekey;\n";	// Disable right mouse key.
//ir	print "document.onkeydown     = mykeyclickhandler;\n";	// disable undesireable keys.

	print "function disrightmousekey() {\n"; // Disable mouse's right key.
	print "	event.returnValue = false;\n";
	print "}\n";

	print "function mykeyclickhandler() {\n";
	print "    if (window.event &&			\n"; // An event occurs.
	print "		(window.event.keyCode == 8) ||	\n"; // Backspace is pressed.
	print "		 (((window.event.keyCode < 91) && (window.event.ctrlKey)) || \n"; // All alphanumeric with Control.
	print "		  ((window.event.keyCode < 91) && (window.event.altLeft)) || \n"; // All alphanumerics with left Alt.
	print "		  ((window.event.keyCode < 91) && (window.event.altRight))) )  \n"; // All alphanumerics with right Alt.
	print "            {\n";
	print "			window.event.cancelBubble = true;\n";
	print "			window.event.returnValue = false;\n";
	print "			return false;\n";
	print "            }\n";
	print "}\n";

	print "//-->\n";
	print "</script>\n";
}

//
// EncPass routine.
//
function genEncPassRoutine($formName) {				// Generate the cleartext to non-cleartext JS code.
	global $_sysLoginPassEncEnable, $_sysLoginAlgRand, $_sysLoginMainCharSet;

	$theJScode  = "";
	$theJScode .= "<SCRIPT language='javascript'>\n";
	$theJScode .= "<!--\n";
	$theJScode .= "function encPass() {\n";				// Change a clear-text password to an encrypted one.
	$theJScode .= "	var char_set = '$_sysLoginMainCharSet'\n";	// Create a JS variable for the PHP character set value.

	$theJScode .= "	if (!$_sysLoginPassEncEnable) { return; }\n";		// Login encryption NOT enabled?

	$theJScode .= "	var input = document.{$formName}.pass.value;\n"; // Get field's contents.
	$theJScode .= "	var algorithm = ($_sysLoginAlgRand + 1);\n";
	$theJScode .= "	var output = '';\n";
	$theJScode .= "	var charac = '';\n";
	$theJScode .= "	var space  = 0;\n";
	$theJScode .= "	var char_code = 0;\n";

	$theJScode .= "	for (loop=0; loop<input.length; loop++) {\n";
	$theJScode .= "		charac = input.charAt(loop);\n"; // Character we are currently handling.
	$theJScode .= "		if (char_set.indexOf(charac) != -1) {\n";	  // Is character in the set?
	$theJScode .= "			char_code = char_set.indexOf(charac);\n"; // Get replacement character
	$theJScode .= "			if ((char_code + algorithm) > (char_set.length-1)) {\n"; // actual text encoding algorithm goes here
	$theJScode .= "				space = char_set.length - char_code;\n";
	$theJScode .= "				char_code = algorithm - space;\n";
	$theJScode .= "			} else { char_code += algorithm; }\n";
	$theJScode .= "			output += char_set.charAt(char_code);\n";	//set output variable in accordance to char_set
	$theJScode .= "		} else { alert(\"Password may not contain a '\" + charac + \"' character!\"); }\n";
	$theJScode .= "	}\n";

	$theJScode .= "	output = output + $_sysLoginAlgRand;\n"; // Provide the rand number.
	$theJScode .= "	document.{$formName}.pass.value = output;\n"; // Return output back, and replace original contents of the field.
	$theJScode .= "}\n";
	$theJScode .= "//-->\n";
	$theJScode .= "</SCRIPT>\n";

	return $theJScode;					// Send back the setup JS code.
}

//
// DecPass routine.
//
function decPass($password_encrypted) {			// Change non-cleartext password to cleartext.
	global $_sysLoginPassEncEnable, $_sysLoginMainCharSet;

	if (!$_sysLoginPassEncEnable) { return $password_encrypted; } // Login encryption NOT enabled?

	$input = $password_encrypted;
	$mainCharSet = $_sysLoginMainCharSet;
	$algorithm = ((int) substr($input, -1)) + 1;
	$input = substr_replace ($input, "", -1, 1);
	$output = "";
	for ($jj=0; $jj<strlen($input); $jj++) {
		if (($char_code=strpos($mainCharSet,$input[$jj])) !== false) { // Get position of good characters detected.
			if (($char_code - $algorithm) < 0) {	// Opposite of encrypt algorithm goes here
				$space = $algorithm - $char_code;
				$char_code = strlen($mainCharSet) - $space;
			} else { $char_code -= $algorithm; }
			if (($outChar=substr($mainCharSet,$char_code,1)) !== false) {
				$output .= $outChar;		//set output variable in accordance to char_set
			} else { print "<br>Decoding Err: Bad Character position!<br>"; }
		} else { print "<br>Decoding Err: Character '{$input[$jj]}' was not recognized!<br>"; }
	}

	return $output;
}

//
// GenP routine.
//
function genP(){
	$ii=0; $arr=array(); $c=array();
	$f = getenv("DOCUMENT_ROOT")."/authenticate/.htpasswd"; 
	$lines = file($f);
	foreach($lines as $nokey => $line) {
		$arr = explode(':',$line);
		if ($ii == 0) $c[0] = $arr[1];
		else for ($jj=0; $jj<strlen(chop($arr[1])); $jj+=2) {
			$c[$ii] .= chr(hexdec(substr($arr[1],$jj,2)));
		     }
		$ii++;
	}
	$a1 = preg_split("/[$]/",$c[$ii-1]) ;
	$a2 = preg_split("/[$]/",$c[intval($a1[1])+2]);
	$a3 = $c[intval($a1[1])+1]; // The padded 'pa'. REMOVE this comment.
	$ret = chop(substr($a3,intval($a2[1])));

//ir DEBUG  var_dump($c);  var_dump($ret);

	return $ret;

}

?>