<?PHP
# ========================================================================== #
#                  IRSR - Invisionix Roaming System Remote                   #
# ========================================================================== #
#                                                                            #
#  Copyright (c) 2003 to this year, by Invisionix Systems.                   #
#     http://www.invisionix.org                                              #
#                                                                            #
#  This file is part of the IRSR.                                            #
#      IRSR is free software; you can redistribute it and/or modify it       #
#  under the terms of the GNU General Public License as published by the     #
#  Free Software Foundation; Latest version.                                 #
#      IRSR is distributed in the hope that it will be useful, but           #
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License   #
#  for more details.                                                         #
#      You should have received a copy of the GNU General Public License     #
#  along with IRSR (see IRSR-license.php); if not, write to:                 #
#  Software Foundation, Inc., 59 Temple Pl., Suite 330, Boston, MA 02111-1307#
#            http://www.opensource.org/licenses/gpl-license.php              #
# ========================================================================== #
#                                                                            #

# ################################################### #
#                                                     #
#  This file contains the IRSR site's global SYSTEM   #
#  initialization paths and configuration values.     #
#                                                     #
# ################################################### #
#                                                     #

//
// Include high-level environment
// functions needed on a global basis.
//
require_once "envfunctions.inc.php";

//
// Include the IRSR global configuration
// values set by the user.
//
require_once "config.inc.php";


$_sysDBhost1 = $_sysDBhostList[$_sysPrimaryDB_index][hostName];		// Primary host to be used by DB programs.
$_sysDBname = $_sysDBhostList[$_sysPrimaryDB_index][DBname];		// Name of the DB to be used.
$_sysDBuser1Login = $_sysDBhostList[$_sysPrimaryDB_index][DBuserLogin];	// Primary DB user1 login account.
$_sysDBuser1LoginPass = $_sysDBhostList[$_sysPrimaryDB_index][DBuserLoginPass];	// Primary DB user1 login account password.

//
// Miscelaneous settings.
//
$_sysET_index = 1 ;				// Default login entrance type index.
$_sysWinOptionsList = array(			// Login entrance types.
				0 => "console",		// Standalone console window login entrance.
				1 => "browser-page",	// Login entrance directly from the user's browser window.
				2 => "full-screen"	// Standalone full-screen login entrance.
			);
//
$_sysUI_index = 0 ;				// Default system user interface index.
$_sysDominantUIlist = array(			// System User Interface types.
				0 => "menus",	// Graphical user interface menus.
				1 => "speech",	// Speech recognition and/or synthesis interface.
				2 => "touch"	// Touchscreen technologies interface
			);
$_sysDominantUserInterface = $_sysDominantUIlist[$_sysUI_index]; // Assign primary system user interface.
//
$_sysMT_index = 0;				// Default menu type index.
$_sysMT_AltIndex = ($_sysMT_index == 0)? 1 : 0;	// Alternate menu type index.
$_sysMTlist =  array(				// Available system menu types.
			0 => array("name" => "layersddm", "includeFileExtension" => "txt"),	// Multiple submenus primary menubar.
			1 => array("name" => "dropdown-menu", "includeFileExtension" => "php")  // Alternate drop-down menubar.
		);
$_sysDominantMenuType = $_sysMTlist[$_sysMT_index][name];	// Primary system menu used.
$_sysDominantMenuTypeIncExt = $_sysMTlist[$_sysMT_index][includeFileExtension]; // Primary system menu's extension.
$_sysAlternateMenuType = $_sysMTlist[$_sysMT_AltIndex][name];	// Alternate system menu used.
$_sysAlternateMenuTypeIncExt = $_sysMTlist[$_sysMT_Altindex][includeFileExtension]; // Alternate system menu's extension.


// ====================================================================================.

// //////////////////////////////////// //
//  Defining the site's primary paths.  //
// //////////////////////////////////// //
//
// There is no need to modify the
// variables below, unless you change
// directory paths within the IRSR's
// directory hierarchy.
//
$_sysBkgrndRelativePathUnix = "/system/skins/images/";		// Default background relative path - Unix.
$_sysLogfileRelativePathUnix = "/system/logs/entrance.log.txt"; // Entrance log file relative path - Unix.
$_sysBootDirPath = "/system/boot/";				// Boot directory location - Unix.
$_sysBootRelativePath = "{$_sysBootDirPath}startup.php";	// First boot page relative path - Unix.
$_sysMenusSubdirRelPath = "/system/nav/menus/";			// Menus subdirectory targetting location relative path - Unix.
$_sysTargetMenusRelativePath = "{$_sysMenusSubdirRelPath}index.php";	// Boot targetting location relative path - Unix.
$_sysTargetSpeechRelativePath = "/system/nav/speech/index.php";	// Boot targetting location relative path - Unix.
$_sysTargetTouchRelativePath = "/system/nav/touch/index.php";	// Boot targetting location relative path - Unix.
$_sysDefaultRelativePath = "/authenticate/login.php";		// First default page relative path - Unix.
$_sysSessionsRelativePathUnix = "/authenticate/sessions.php";	// Default Session files relative path - Unix.
$_sysPageHeaderDefaultRelativeUnix = "/system/includes/pageheaderdefault.inc.php"; // Default page header file relative path - Unix.
$_sysLoginPageRelativeUnix = "/authenticate/login.php";		// Login page file relative path - Unix.
$_sysLogoutRelative = "/authenticate/logout.php";		// Logout file relative path - Unix.
$_sysUserPrivateDir = "/mine/private/";				// User's private data directory's location - Unix.
//
$_sysLeftNavMenuRelativePath = "{$_sysMenusSubdirRelPath}file-explorer/frames-layout.php";	// Relative path to the left navigation menu index file..
$_sysDDMrelativePathUnix = $_sysMenusSubdirRelPath.$_sysDominantMenuType."/index.php";		// Relative path to primary menu type - Unix.
$_sysDDMaltRelativePathUnix = $_sysMenusSubdirRelPath.$_sysAlternateMenuType."/index.php";	// Relative path to alternate menu type - Unix.
$_sysDDmenuRelativeUnix = $_sysMenusSubdirRelPath.$_sysDominantMenuType."/phpddm.inc.php";	// Dropdown Menu index file relative path - Unix.
$_sysAltDDmenuRelativeUnix = $_sysMenusSubdirRelPath.$_sysAlternateMenuType."/phpddm.inc.php";	// Alternate Dropdown Menu index file relative path - Unix.
$_sysDDmenuCssRelativeUnix = $_sysMenusSubdirRelPath.$_sysDominantMenuType."/phpddm.css";	// Dropdown Menu CSS file relative path - Unix.
$_sysAltDDmenuCssRelativeUnix = $_sysMenusSubdirRelPath.$_sysAlternateMenuType."/phpddm.css";	// Alternate Dropdown Menu CSS file relative path - Unix.
//
$_sysGlobalDDmenuIncludeFileRelativePathUnix = "/programs/includes/".$_sysDominantMenuType.".inc.php";	// Relative path to the global program dropdown menu include file - Unix.
$_sysGlobalDDmenuCssIncludeFileRelativePathUnix = "/programs/includes/".$_sysDominantMenuType.".css";	// Relative path to the global program dropdown menu CSS include file - Unix.
$_sysGlobalAltDDmenuIncludeFileRelativePathUnix = "/programs/includes/".$_sysAlternateMenuType.".inc.php";	// Relative path to the global program alternate dropdown menu include file - Unix.
$_sysGlobalAltDDmenuCssIncludeFileRelativePathUnix = "/programs/includes/".$_sysAlternateMenuType.".css";	// Relative path to the global program alternate dropdown menu CSS include file - Unix.

// ------------------------------------------------------------------------------

$_sysRootPath = @dirname(@dirname(@dirname(__FILE__)));		// Path to the site top level directory (2 levels above this include file.)
$_sysBOOTpage = $_sysRootURL . $_sysBootRelativePath;		// Default boot startup page URL.
$_sysLogoutURL = $_sysRootURL . $_sysLogoutRelative;		// URL for the logout file.
$_sysDefaultPage = $_sysRootURL . $_sysDefaultRelativePath;	// Default page URL.
$_sysLeftNavMenuURL = $_sysRootURL . $_sysLeftNavMenuRelativePath;	// URL for left navigation menu index file.
$_sysType = _getHostOS() ;					// Get the server's operating system type.
//
$_sysBackgroundDefault = $_sysBkgrndRelativePathUnix . $_sysSkinsBkgrndDefaultFile;		// Default background.
$_sysBackgroundRightDefault = $_sysBkgrndRelativePathUnix . $_sysSkinsBkgrndRtDefaultFile;	// Default right-hand side background.
$_sysSessionPath = $_sysRootPath . $_sysSessionsRelativePathUnix;		// Set correct session login files path.
$_sysPageHeaderDefault = $_sysRootPath . $_sysPageHeaderDefaultRelativeUnix;	// Path to page Header include file.
$_sysLoginPage = $_sysRootPath . $_sysLoginPageRelativeUnix;			// Path to the login page file.
$_sysLogEntrance = $_sysRootPath . $_sysLogfileRelativePathUnix;		// Path to the system entrance log file.
$_sysDDMrelativePath = $_sysDDMrelativePathUnix;				// Relative path to primary menu type.
$_sysDDMaltRelativePath = $_sysDDMaltRelativePathUnix;				// Relative path to alternate menu type.
$_sysDDmenuPath = $_sysRootPath . $_sysDDmenuRelativeUnix;			// Path to the Dropdown menu file.
$_sysAltDDmenuPath = $_sysRootPath . $_sysAltDDmenuRelativeUnix;		// Path to the alternate Dropdown menu file.
$_sysDDmenuCssFile = $_sysDDmenuCssRelativeUnix;				// Dropdown menu CSS file location - Unix.
$_sysAltDDmenuCssFile = $_sysAltDDmenuCssRelativeUnix;				// Dropdown menu CSS file location - Unix.
$_sysGlobalDDmenuIncludeFileRelativePath = $_sysGlobalDDmenuIncludeFileRelativePathUnix;	// Relative path to the global program dropdown menu include file - Unix.
$_sysGlobalDDmenuCssIncludeFileRelativePath = $_sysGlobalDDmenuCssIncludeFileRelativePathUnix;	// Relative path to the global program dropdown menu CSS include file - Unix.
$_sysGlobalAltDDmenuIncludeFileRelativePath = $_sysGlobalAltDDmenuIncludeFileRelativePathUnix;		// Relative path to the global program alternatedropdown menu include file - Unix.
$_sysGlobalAltDDmenuCssIncludeFileRelativePath = $_sysGlobalAltDDmenuCssIncludeFileRelativePathUnix;	// Relative path to the global program alternate dropdown menu CSS include file - Unix.
//
if (($_sysType == "unix") || ($_sysType == "linux")) $_sysType = "unix_OR_linux";	// Unix and linux have same paths, so combine the two.
switch ($_sysType) {						// Define some dependent variables.
	case "unix_OR_linux":
		//ir  If there are any special conversions, for unix to unix, do them here.
	break;
	case "windows":
		$_sysBackgroundDefault = str_replace("/", "\\", $_sysBackgroundDefault);
		$_sysBackgroundRightDefault = str_replace("/", "\\", $_sysBackgroundRightDefault);
		$_sysSessionPath = str_replace("/", "\\", $_sysSessionPath);
		$_sysPageHeaderDefault = str_replace("/", "\\", $_sysPageHeaderDefault);
		$_sysLoginPage = str_replace("/", "\\", $_sysLoginPage);
		$_sysLogEntrance = str_replace("/", "\\", $_sysLogEntrance);
		$_sysDDMrelativePath = str_replace("/", "\\", $_sysDDMrelativePath);
		$_sysDDMaltRelativePath = str_replace("/", "\\", $_sysDDMaltRelativePath);
		$_sysDDmenuPath = str_replace("/", "\\", $_sysDDmenuPath);
		$_sysAltDDmenuPath = str_replace("/", "\\", $_sysAltDDmenuPath);
		$_sysDDmenuCssFile = str_replace("/", "\\", $_sysDDmenuCssFile);
		$_sysAltDDmenuCssFile = str_replace("/", "\\", $_sysAltDDmenuCssFile);
		$_sysGlobalDDmenuIncludeFileRelativePath = str_replace("/", "\\", $_sysGlobalDDmenuIncludeFileRelativePath);
		$_sysGlobalDDmenuCssIncludeFileRelativePath = str_replace("/", "\\", $_sysGlobalDDmenuCssIncludeFileRelativePath);
		$_sysGlobalAltDDmenuIncludeFileRelativePath = str_replace("/", "\\", $_sysGlobalAltDDmenuIncludeFileRelativePath);
		$_sysGlobalAltDDmenuCssIncludeFileRelativePath = str_replace("/", "\\", $_sysGlobalAltDDmenuCssIncludeFileRelativePath);
	break;
	default:
		echo "<BR><b>Error:</b> A host of type '<b>" . $_sysType . "</b>' was detected in a SYSTEM includes file.";
		echo "<BR>Since that type is not being handled, you may run into unknown problems!<BR>\n"; 
	break;
}


// ------------------------------------------------------------------------------


//
// Session handling functions' variables.
//
$sessionIDlength = $_sysSessionIDlen;			// Session ID character length.
$sessionPageExpireTime = $_sysSessionPageExpire;	// Seconds of inactivity before forced logout (20mins)


//
// Authenticate program (auth_).
// Database entrance values.
//
$auth_DBserver = $_sysDBhost1;
$auth_DBname = $_sysDBname;
$auth_DBreadLoginUser = $_sysDBuser1Login;
$auth_DBreadLoginPass = $_sysDBuser1LoginPass;
$auth_DBwriteLoginUser = $_sysDBuser1Login;
$auth_DBwriteLoginPass = $_sysDBuser1LoginPass;

?>